'use strict';
evaidyaApp.controller('AllergiesListCtrl',['$scope',  '$location', '$ionicPopup', 'allergiesData', 'eVaidyaCache',function AllergiesListCtrl($scope, $location,$ionicPopup, allergiesData, eVaidyaCache) {
    $scope.viewOnly = false;
    $scope.showSelected = false;
    $scope.itemButtons = [
        {
            text: 'Delete',
            type: 'button-assertive',
            onTap: function(item) {
                $scope.deleteItem(item);            }
        },
        {
            text: 'Edit',
            type: 'button-calm',
            onTap: function(item) {
                var hashpath = "/evaidya/allergiesdetail/"+ item;
                $location.path(hashpath);
            }
        }
    ];

    allergiesData.populateStaticList();
    if(allergiesData.uname === $scope.uname && allergiesData.allergiesList )
        $scope.allergiesList =  allergiesData.allergiesList;
    else
    {
        allergiesData.allergiesList = null;
        allergiesData.getAllergiesList().then(function(allergiesList){
        $scope.allergiesList = allergiesList;
        allergiesData.allergiesList =  $scope.allergiesList;
        allergiesData.uname = $scope.uname;
    }, function(response){ console.log(response);});
    }

    $scope.dislimit=function(note)
    {
        var limitnote=note;
        if(note.length>20)
        {
            limitnote= note.substring(0,20) ;
        }
        return limitnote;
    }
    $scope.deleteItem  = function (listIndex) {
        $ionicPopup.confirm({
            title: 'Delete condition?',
            content: 'Are you sure you want to delete?'
        }).then(function(res) {
                if(res) {
                    //$scope.allergiesList[listIndex]
                    $scope.allergiesList = allergiesData.allergiesList;
                    allergiesData.allergies.delete({uname:$scope.uname,id:$scope.allergiesList[listIndex]._id},function () {
                            $scope.allergiesList.splice(listIndex, 1);
                        },
                        function (response) {
                        });
                } else {
                }
            });
    }
}]);

evaidyaApp.controller('AllergiesDetailCtrl', ['$scope', '$location', '$stateParams', '$filter', 'allergiesData', 'eVaidyaCache', function AllergiesDetailCtrl($scope, $location, $stateParams,$filter, allergiesData, eVaidyaCache) {
    $scope.allergiesList = allergiesData.allergiesList;
    $scope.severityValues= ["Severe","Moderate","Mild"];
    var isNew = false;
    $scope.allergiesStaticList = eVaidyaCache.allergiesStaticList();
    allergiesData.getAllergiesList().then(function(allergiesList){
        $scope.allergiesList = allergiesList;
        allergiesData.allergiesList =  $scope.allergiesList;
    if($stateParams.id >= 0)
    // shallow copy the object
        $scope.allergiesData = jQuery.extend({}, $scope.allergiesList[$stateParams.id]);
    else if($stateParams.id === "-1")
    {
        $scope.allergiesData = {measureDate:new Date()
            , Allergen: ""
            , Reaction: ""
            , Severity: "Mild"
            , Note: ""
            ,patientId: $scope.getUserName()};
        isNew = true;
    }
    else // clone the first element
    {
        $scope.allergiesData = jQuery.extend({}, $scope.allergiesList[0]);
        isNew = true;
    }
    $scope.allergiesData.measureDate = $filter("date")($scope.allergiesData.measureDate, 'yyyy-MM-dd');
    });
    $scope.save  = function () {
        if(isNew)
        {
            allergiesData.allergies.save({uname: $scope.uname},$scope.allergiesData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                    allergiesData.allergiesList.push(event);
                    // sort - very important
                    allergiesData.allergiesList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
        }
        else
            allergiesData.allergies.update({uname: $scope.uname},$scope.allergiesData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                    jQuery.each(allergiesData.allergiesList, function (j, el) {
                        if (event._id === el._id) {
                            allergiesData.allergiesList[j] = event;
                            return false; // break the loop
                        }
                    });
                    // sort - very important
                    allergiesData.allergiesList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
    };

}]);
