'use strict';
evaidyaApp.controller('ArticlesListCtrl',['$scope','$routeParams', '$rootScope', '$location', 'articlesData', 'eVaidyaCache', function ArticlesListCtrl($scope,$routeParams, $rootScope, $location, articlesData, eVaidyaCache) {

    $scope.viewOnly = false;
    $scope.currentPage = 1;
    if(articlesData.currentPage)
        $scope.currentPage =articlesData.currentPage;
    $scope.itemsPerPage = 9;
    $scope.searcharticle="";

    $scope.getData = function() {
            articlesData.getArticlesList($scope.searcharticle, $scope.itemsPerPage, $scope.currentPage).then(function (data) {
                $scope.articlesList1=[];
                $scope.articlesList2=[];
                $scope.articlesList3=[];
                var articlesList = data.items;
                $scope.numPages = data.pages;
                $scope.totalItems = data.totalCount;
                $.each(articlesList, function (j, el) {
                    var n = el.introtext.length;
                    if(n > 150)
                        el.introtext = el.introtext.substring(0,150);
                    el.created = new Date(el.created);
                    if(j <3)
                        $scope.articlesList1.push(el);
                    else if(j <6)
                        $scope.articlesList2.push(el);
                    else if(j <9)
                        $scope.articlesList3.push(el);
                    // selected field only used as required
                    //            el.selected = false;
                });
                // sort - very important
                articlesList.sort(function (el1, el2) {
                    return (el2.created > el1.created) ? 1 : ( (el1.created > el2.created) ? -1 : 0 );
                });
                $scope.articlesList = articlesList;
                articlesData.articlesList =  $scope.articlesList;
                articlesData.uname = $scope.uname;
            }, function (response) {
                console.log(response);
            });
        }

    $scope.$watch('currentPage', function(newPage){
        $scope.getData();
        articlesData.currentPage = newPage;
        //or any other code here
    });

    $scope.showDetail = function(ind)
    {
        var hashpath = '/articles/' + ind;
        $location.path(hashpath)
        console.log(ind);
    }


//for seo friendly URL's
    $scope.title=function(title)
    {

        var title= title.replace(/\s+/g, '-'); // here replacing space with '-'
        return title;
    }


//    $scope.getData();
}]);


evaidyaApp.controller('ArticleDetailCtrl', ['$scope', '$location', '$routeParams','articlesData', 'eVaidyaCache', function ArticleDetailCtrl($scope, $location, $routeParams,articlesData, eVaidyaCache) {
    $scope.article={};

    articlesData.getArticle($routeParams.id).then(function (data) {
            $scope.article = data[0];
        }, function (response) {
            console.log(response);
        });

    $scope.metaSave=function()
    {

        articlesData.articles.update({uname: $scope.uname}, $scope.article, function (event) {
                articlesData.articlesList = null; // clear discussionList

            },
            function (response) {
            });
        $scope.$back();
    }
}]);

evaidyaApp.controller('AddArticleCtrl', ['$scope', 'articlesData','eVaidyaCache','filesData',  function AddArticleCtrl($scope,articlesData,eVaidyaCache,filesData) {
    $scope.article={};
    $scope.category=['Children Healthcare','Beauty & Skin Care','Diabetes','Yoga & Meditation','Exercise & Fitness','Parenting','Pregnancy','Weight Loss','Stress & Anxiety','Sex & Relationships','Womens Health','Nutrition','Heart','Mens Health','Mental Health'];
    $scope.selectedCategory="Exercise & Fitness";

    //for upload article images

    $scope.fileToken = new Date().getTime();
    $scope.getFileInfo = function(e) {
        return $.map(e.files, function(file) {
            var info = file.name;

            // File size is not available in all browsers
            if (file.size > 0) {
                info  += " (" + Math.ceil(file.size / 1024) + " KB)";
            }
            return info;
        }).join(", ");
    }



    var filename=[];
    $scope.onUpload = function(event) {
        //storing file name in cache for storing filename in consultation schema
        filename.push($scope.fileToken+event.files[0].name);

        eVaidyaCache.setFileName( filename);
        event.data = {username: $scope.uname, fileToken: $scope.fileToken,   kiosk: $scope.kioskName};
    }



    $scope.onRemove = function(event) {
        event.data = {username: $scope.uname, fileToken: $scope.fileToken, kiosk: $scope.kioskName};
    };

    $scope.onComplete = function(event) {
        filesData.filesList = null; // clear the cache in service
    };

    $scope.uploadOptions =   {
        async: {
            saveUrl: "/evaidya_api/upload/articles",
            removeUrl: "/evaidya_api/articles/deleteuploaded",
            autoUpload: true
        },
        remove: $scope.onRemove,
        upload: $scope.onUpload,
        complete: $scope.onComplete
    };


    $scope.save=function()
    {
        $scope.article.category=$scope.selectedCategory;
        $scope.article.images="images/articles/"+eVaidyaCache.selectFileName();// file name from cache

        if(!$scope.article.title || $scope.article.title.length<10)
        {
            $scope.errorMsg="Please enter article title morethan 10 characters";
        }
        else if(!$scope.article.content|| $scope.article.content.length<250)
        {
            $scope.errorMsg="Please enter article details more than 250 characters";
        }
        else
        {
            $scope.article.author=$scope.uname;
            $scope.article.publish=false;

            articlesData.addArticle($scope.article) ;
            eVaidyaCache.setFileName(""); //clear file Name
            $scope.successMsg="Thanks for writing article. eVaidya Admin will publish your article.";
        }

    }
}]);










