'use strict';
evaidyaApp.controller('DiscussionsListCtrl', ['$scope', '$stateParams', '$rootScope', '$location', 'discussionsData', 'eVaidyaCache','$ionicPlatform', function DiscussionsListCtrl($scope, $stateParams, $rootScope, $location, discussionsData, eVaidyaCache,$ionicPlatform) {

 $scope.noMoreItemsAvailable=false;//for loading button

    $scope.model = {
        viewOnly:false,
        currentPage:1,
        itemsPerPage:10,
        numPages: 0,
        totalItems:0,
        filterTitle:""
    }

    $scope.showNav = function()
    {
        if($scope.model.currentPage < $scope.model.numPages)
            return true;
    }

    $scope.searchTitle = function()
    {
        $scope.model.currentPage =1;
        $scope.getData();
    }

    $scope.incrementPage = function()
    {
        $scope.model.currentPage ++;
        $scope.getData();
    }

    $scope.decrementPage = function()
    {
        $scope.model.currentPage --;
        $scope.getData();
    }


    if (discussionsData.currentPage)
        $scope.model.currentPage = discussionsData.currentPage;

    $scope.discussUser = function (username) {

        var usrname = username.split('@');
        return usrname[0];
    }
    if ($stateParams.option === "false")
        $scope.createCapapble = false;
    else
        $scope.createCapapble = true;
    $scope.getData = function () {

        discussionsData.discussionList = null;
        discussionsData.getDiscussionsList($scope.model.filterTitle, $scope.model.itemsPerPage, $scope.model.currentPage).then(function (data) {
            var discussionsList = data.items;

            $scope.model.numPages = data.pages;
            $scope.model.totalItems = data.totalCount;
            $scope.discussionsList = discussionsList;
            discussionsData.discussionList = data;
            discussionsData.filterTitle = $scope.model.filterTitle;
            discussionsData.itemsPerPage = $scope.model.itemsPerPage;
            discussionsData.currentPage = $scope.model.currentPage;
            discussionsData.uname = $scope.uname;
            
            $scope.noMoreItemsAvailable=true;//for loading button
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }, function (response) {
            console.log(response);
        });
    }
    $scope.dislimit=function(title)
    {
      var limittitle=title;
        if(title.length>40)
        {
          limittitle= title.substring(0,40) ;
        }
        return limittitle;
    }


    $scope.showDetail = function (ind) {
        var hashpath = '/discussions/' + ind;
        $location.path(hashpath);
        console.log(ind);
    }


    $scope.newdiscuss = function () {
        discussionsData.discussionList = undefined;
        eVaidyaCache.evCache.put("redirect", "/newdiscussion/-1"); // incase of redirect
//        $location.parent().path("/oluserindex.html#!/newdiscussion/-1");
    }

//for SEO friendly URL's
    $scope.discussdetail=function(title)
    {
        if(title !== undefined)
        {
            var title= title.replace(/\s+/g, '-');//here  discussion tile replacing space with '-'
            return title;
        }
    }

    $scope.discussID=function(ind)
    {
        return $scope.discussionsList[ind]._id;
    }
    $scope.getData();
}]);



evaidyaApp.controller('ModerateQADetailCtrl', ['$scope', '$http', '$location', '$stateParams',  function ModerateQADetailCtrl($scope, $http, $location, $stateParams) {

    $scope.docSpeciality = ["--Select--","Cardiology or Heart ailments","Cosmetic & Plastic Surgery","Dermatology or Skin ailments","Diabetes","Diet and Nutrition","Endocrinology and Hormones","ENT","Gastric Disorder","General & Family Health","Gynaecology","Sexology","Alternative Medicine","Nephrology or Kidney related","Neurology","Oncology or cancer","Ophthalmology or eye","Orthopaedic or bone","Paediatrics or Kids health","Psychiatry and Mental health","Psychology","Pulmonology or lung","Radiology","Trichology or Hair","Urology"];

    $scope.approve=function(id, title, content, category, keyWords, descr)
    {
        $http.post(APIUrl +'/evaidya_api/approveQuestion/' + id,{params: {title:title, content:content, category: category, keyWords:keyWords, descr:descr}}).success(function(data){
            alert("You have approved this question for display in the Q&A");
        }).error(function(error) {
            });
        $scope.$back();
    }

    $scope.reject=function(id)
    {
        $http.put(APIUrl +'/evaidya_api/rejectQuestion/'+id).success(function(data){}).error(function(error){});
        $scope.$back();
    }

    var id=$stateParams.id;

    $http.get(APIUrl +'/evaidya_api/discussions/'+id).success(function(data){
        $scope.discussion=data;
        var index = 0;
        if ( (data.category != null) && (data.category.trim().length != 0) ) {
            index = $scope.docSpeciality.indexOf(data.category);
            if (index < 0) {    // the db had some junk or discontinued category, we don't want it anymore
                index = 0;
            }
        }
        $scope.discussion.category = $scope.docSpeciality[index];
    }).error(function(error){});

    $scope.discussUser = function (username) {
        if (username !== undefined) {
            var usrname = username.split('@');
            return usrname[0];
        } else {
            return "";
        }
    }
}]);


evaidyaApp.controller('ModerateQARejectCtrl', ['$scope', '$http', '$location', '$stateParams',  function ModerateQARejectCtrl($scope, $http, $location, $stateParams) {
    //$scope.emailTxt = "<html> <body> <div> <b> Hello from www.evaidya.com</b></div></body></html>"; // appears as the dafault, can be modified

    var strTemp = "<h4>";

    strTemp += "Dear Customer, <BR><BR> Greetings from eVaidya.com! <BR><BR> Thank you for posting your Free question on eVaidya.com. <BR><BR> We regret to inform you that we are unable to publish your question because of one of the following reasons:";
    strTemp += "<BR><BR> 1. Not following our standard guidelines:";
    strTemp += "<BR> &nbsp; &nbsp; &nbsp; &nbsp; a) Use suitable Title for your Health Problem. Highlight the problem that you are facing. Please limit the Title to 100 characters.";
    strTemp += "<BR> &nbsp; &nbsp; &nbsp; &nbsp; b) Explain your problem in detail for the Doctors to understand your present conditions and suggest a suitable advice.";
    strTemp += "<BR> &nbsp; &nbsp; &nbsp; &nbsp; c) Enter your Name, Age and Gender in the details section.";
    strTemp += "<BR> &nbsp; &nbsp; &nbsp; &nbsp; d) We suggest you to go for our Health Plans for a detailed and quick consultations from our panel Doctors.";
    strTemp += "<BR><BR> 2. Question is too personal to post it publicly.";
    strTemp += "<BR><BR> 3. The question that you have posted needs a detailed review by the Doctors. In such case you need to go for our Heath Plans.";
    strTemp += "<BR><BR> We once again thank you for contacting us.";
    strTemp += "<BR><BR> For any queries please email our customer care at customercare@evaidya.com, or call us toll free at # 1800 1030 365.";
    strTemp += "<BR><BR> Stay Healthy!!! <BR><BR> Regards, <BR> Team eVaidya.com";

    strTemp += "</h4>";

    $scope.emailTxt = strTemp;

    $('#emailTxt').cleditor()[0].$area.val($scope.emailTxt);
    $('#emailTxt').cleditor()[0].updateFrame();
    $('#emailTxt').cleditor()[0].updateTextArea();

    var id=$stateParams.id;
    $http.get(APIUrl +'/evaidya_api/discussions/'+id).success(function(data){
        $scope.discussion=data;
    }).error(function(error){});

    $scope.reject=function(id) {
        $scope.emailTxt = $("#emailTxt").val();
        $http.put(APIUrl +'/evaidya_api/rejectQuestion/'+id).success(function(data){
            $http.post(APIUrl +'/evaidya_api/moderateQASendRejectEmail/', {param:{username: $scope.discussion.username, title: $scope.discussion.title, emailTxt: $scope.emailTxt}}).success(function(result){
                alert ("Sent the email to the user about the rejection of the question");
            }).error(function(error){});
        }).error(function(error){
            });
        $location.path('/moderateQA');
    }

    $scope.discussUser = function (username) {
        if (username !== undefined) {
            var usrname = username.split('@');
            return usrname[0];
        } else {
            return "";
        }
    }
}]);



evaidyaApp.controller('ModerateQACtrl', ['$scope', '$http', '$location', '$stateParams',  function ModerateQACtrl($scope, $http, $location, $stateParams) {
    $scope.currentPage = 1;
    $scope.itemsPerPage = 10;
    $scope.filterTitle = "";
    var word="";
    $http.get(APIUrl +'/evaidya_api/moderateQA',{params:{word:word,resultPerPage:$scope.itemsPerPage,pageNumber:$scope.currentPage}}).success(function(data){
        $scope.moderatelist=data;
        $scope.totalItems=data.totalCount;
    }).error(function(err){});

    $scope.$watch('currentPage', function (newPage) {
        $scope.currentPage = newPage;
        $http.get(APIUrl +'/evaidya_api/moderateQA',{params:{word:word,resultPerPage:$scope.itemsPerPage,pageNumber:$scope.currentPage}}).success(function(data){
            $scope.moderatelist=data;
            $scope.totalItems=data.totalCount;
        }).error(function(err){});
    });

    //for SEO friendly URL's
    $scope.discussdetail=function(title)
    {
        if(title !== undefined)
        {
            var lTitle= title.replace(/\s+/g, '-');//here  discussion tile replacing space with '-'
            return lTitle;
        }
    }

    $scope.discussID=function(ind)
    {
        return $scope.data[ind]._id;

    }

    $scope.discussUser = function (username) {
        var usrname = username.split('@');
        return usrname[0];
    }

    $scope.dislimit=function(title)
    {
        var limittitle=title;
        if(title.length>150)
        {
            limittitle= title.substring(0,150) ;
        }
        return limittitle;
    }
}]);




evaidyaApp.controller('ModerateAnswerDetailCtrl', ['$scope', '$http', '$location', '$stateParams',  function ModerateAnswerDetailCtrl($scope, $http, $location, $stateParams) {

    $scope.approve=function(id, parent_id, title, content, username) {
        $http.post(APIUrl +'/evaidya_api/approveAnswer/' + id,{params: {parent_id: parent_id, title:title, content:content, username: username}}).success(function(data){
            alert("You have approved this answer for display in the Q&A");
        }).error(function(error) {
            });
        $scope.$back();
    }

    $scope.reject=function(id) {
        $http.put(APIUrl +'/evaidya_api/rejectAnswer/'+id).success(function(data){}).error(function(error){});
        $scope.$back();
    }

    var id=$stateParams.id;

    $http.get(APIUrl +'/evaidya_api/discussions/'+id).success(function(data){
        $scope.discussion=data;
    }).error(function(error){});

    $scope.discussUser = function (username) {
        if (username !== undefined) {
            var usrname = username.split('@');
            return usrname[0];
        } else {
            return "";
        }
    }
}]);


evaidyaApp.controller('ModerateAnswerRejectCtrl', ['$scope', '$http', '$location', '$stateParams',  function ModerateAnswerRejectCtrl($scope, $http, $location, $stateParams) {
    /**
     var strTemp = "<h4>";
     strTemp += "Dear Customer, <BR><BR> Greetings from eVaidya.com! <BR><BR> Thank you for posting your Free question on eVaidya.com. <BR><BR> We regret to inform you that we are unable to publish your question because of one of the following reasons:";
     strTemp += "<BR><BR> 1. Not following our standard guidelines:";
     strTemp += "<BR> &nbsp; &nbsp; &nbsp; &nbsp; a) Use suitable Title for your Health Problem. Highlight the problem that you are facing. Please limit the Title to 100 characters.";
     strTemp += "<BR> &nbsp; &nbsp; &nbsp; &nbsp; b) Explain your problem in detail for the Doctors to understand your present conditions and suggest a suitable advice.";
     strTemp += "<BR> &nbsp; &nbsp; &nbsp; &nbsp; c) Enter your Name, Age and Gender in the details section.";
     strTemp += "<BR> &nbsp; &nbsp; &nbsp; &nbsp; d) We suggest you to go for our Health Plans for a detailed and quick consultations from our panel Doctors.";
     strTemp += "<BR><BR> 2. Question is too personal to post it publicly.";
     strTemp += "<BR><BR> 3. The question that you have posted needs a detailed review by the Doctors. In such case you need to go for our Heath Plans.";
     strTemp += "<BR><BR> We once again thank you for contacting us.";
     strTemp += "<BR><BR> For any queries please email our customer care at customercare@evaidya.com, or call us toll free at # 1800 1030 365.";
     strTemp += "<BR><BR> Stay Healthy!!! <BR><BR> Regards, <BR> Team eVaidya.com";
     strTemp += "</h4>";
     $scope.emailTxt = strTemp;
     */

    $scope.emailTxt = "Dear Doctor, sorry to tell you that your reply cannot be published because...";

    $('#emailTxt').cleditor()[0].$area.val($scope.emailTxt);
    $('#emailTxt').cleditor()[0].updateFrame();
    $('#emailTxt').cleditor()[0].updateTextArea();

    var id=$stateParams.id;
    $http.get(APIUrl +'/evaidya_api/discussions/'+id).success(function(data){
        $scope.discussion=data;
    }).error(function(error){});

    $scope.reject=function(id) {
        $scope.emailTxt = $("#emailTxt").val();
        $http.put(APIUrl +'/evaidya_api/rejectAnswer/'+id).success(function(data){
            $http.post(APIUrl +'/evaidya_api/moderateAnswerSendRejectEmail/', {param:{username: $scope.discussion.username, title: $scope.discussion.title, emailTxt: $scope.emailTxt}}).success(function(result){
                alert ("Sent the email to the doctor about the rejection of the reply");
            }).error(function(error){});
        }).error(function(error){
            });
        $location.path('/moderateAnswers');
    }

    $scope.discussUser = function (username) {
        if (username !== undefined) {
            var usrname = username.split('@');
            return usrname[0];
        } else {
            return "";
        }
    }
}]);

evaidyaApp.controller('ModerateAnswersCtrl', ['$scope', '$http', '$location', '$stateParams',  function ModerateAnswersCtrl($scope, $http, $location, $stateParams) {
    $scope.currentPage = 1;
    $scope.itemsPerPage = 10;
    $scope.filterTitle = "";
    var word="";
    $http.get(APIUrl +'/evaidya_api/moderateAnswers',{params:{word:word,resultPerPage:$scope.itemsPerPage,pageNumber:$scope.currentPage}}).success(function(data){
        $scope.moderateAnswerslist=data;
        $scope.totalItems=data.totalCount;
    }).error(function(err){});

    $scope.$watch('currentPage', function (newPage) {
        $scope.currentPage = newPage;
        $http.get(APIUrl +'/evaidya_api/moderateAnswers',{params:{word:word,resultPerPage:$scope.itemsPerPage,pageNumber:$scope.currentPage}}).success(function(data){
            $scope.moderateAnswerslist=data;
            $scope.totalItems=data.totalCount;
        }).error(function(err){});
    });

    $scope.discussdetail=function(title) {
        if(title !== undefined) {
            var lTitle= title.replace(/\s+/g, '-');//here  discussion tile replacing space with '-'
            return lTitle;
        }
    }

    $scope.discussID=function(ind) {
        return $scope.data[ind]._id;
    }

    $scope.discussUser = function (username) {
        var usrname = username.split('@');
        return usrname[0];
    }

    $scope.dislimit=function(title) {
        var limittitle=title;
        if(title.length>150) {
            limittitle= title.substring(0,150) ;
        }
        return limittitle;
    }
}]);




evaidyaApp.controller('DiscussionDetailCtrl', ['$scope', '$http', '$location', 'userData', '$stateParams', 'discussionsData', 'eVaidyaCache','$rootScope','$ionicPopup','messageService','$ionicPlatform', function DiscussionDetailCtrl($scope, $http, $location, userData, $stateParams, discussionsData, eVaidyaCache,$rootScope,$ionicPopup,messageService,$ionicPlatform) {


    $scope.userType='not_registered';
    
    if ($rootScope.userMenu) {
        $scope.userType='user';
    }
    if ($rootScope.doctorMenu) {
        $scope.userType='doctor';
    }
    if ($rootScope.adminMenu) {
        $scope.userType='admin';
    }


    $scope.errorMsg="";
    
  
     $scope.noMoreItemsAvailable=false;//for loading button
  
      


    $scope.docSpeciality = ["--Select--","Cardiology or Heart ailments","Cosmetic & Plastic Surgery","Dermatology or Skin ailments","Diabetes","Diet and Nutrition","Endocrinology and Hormones","ENT","Gastric Disorder","General & Family Health","Gynaecology","Sexology","Alternative Medicine","Nephrology or Kidney related","Neurology","Oncology or cancer","Ophthalmology or eye","Orthopaedic or bone","Paediatrics or Kids health","Psychiatry and Mental health","Psychology","Pulmonology or lung","Radiology","Trichology or Hair","Urology"];
    $scope.selectedSpeciality = $scope.docSpeciality[0];

    

    //for limit the related Q&A limit
    $scope.dislimit=function(title,range)
    {
        var limittitle=title;
        if(title.length>range)
        {
            limittitle= title.substring(0,range) ;
        }
        return limittitle;
    }

    $scope.setSelectedDoc= function(doc) {
        if(doc)
            eVaidyaCache.setSelectedDoc (doc); // store the state

        eVaidyaCache.consultationCurrentSheet = 0;
        eVaidyaCache.evCache.put("redirect", "/consult/"+ doc.username); // incase of redirect

    }

    //for SEO friendly URL's
    $scope.discussdetail=function(title)
    {
        if(title !== undefined)
        {
            var lTitle= title.replace(/\s+/g, '-');//here  discussion tile replacing space with '-'
            return lTitle;
        }
    }


    //this usefull add to server

    $scope.answerlike=function(id,title,docname)
    {
        $http.get(APIUrl +'/evaidya_api/checklikes/answered/likes/'+id).success(function(data){
            if(data=="Allowed")
            {
                $http.put(APIUrl +'/evaidya_api/answerlikes/' +id).success(function (data) {
                    $scope.bindall();
                    $scope.addengagement(id,title,"Answer","1","likes",docname);
                    console.log("Patient ID:"+$scope.uname+"DoctorId:"+data.username+"Discussion Id:"+id);
                     messageService.sendDiscussionLikes($scope.uname, docname, id);
                    
                }). error(function(error){

                    });
          }
            else
            {
               
               $ionicPopup.alert({
               title: 'Notice!',
               content: 'You already rated for this Q&A, Wait for 24 Hrs to change it'
               }).then(function(res) {
               console.log('You already rated for this Q&A, Wait for 24 Hrs to change it');
               });
            }
        }).error(function(error){})
    }


    //check rating to display

    $scope.checkrating=function(rate,original)
    {
        if(rate<=original)
        {
            return "ion-ios7-star";
        }
        else
        {
            return "ion-ios7-star-outline";
        }
    }


    $scope.addengagement=function(id,title,type,notification,notifytype,ownerby)
    {
        $http.post(APIUrl +'/evaidya_api/doctorengagement',{param:{id:id,title:title,type:type,notification:notification,notifytype:notifytype,ownerby:ownerby}}).success(function(data){


        }).error(function(error){})
    }
    //doctor rating
    $scope.rating=function(rate,docid,docname)
    {
        $http.get(APIUrl +'/evaidya_api/checklikes/profile/rating/'+docid).success(function(data)
        {
            if(data=="Allowed")
            {
                $http.put('/evaidya_api/rating/' +docid+'/'+rate).success(function (data) {
                    $scope.bindall();
                    $scope.addengagement(docid,docname,"Profile","1","rating",docname);
                    console.log("From Rating Patient ID:"+$scope.uname+"DoctorId:"+data.username+"Discussion Id:"+data._id);
                    messageservice.sendDiscussionRating($scope.uname,docname,data._id);
                }). error(function(error){

                    });
            }
            else
            {
               $ionicPopup.alert({
               title: 'Notice!',
               content: 'You already rated for this Q&A, Wait for 24 Hrs to change it'
               }).then(function(res) {
               console.log('You already rated for this Q&A, Wait for 24 Hrs to change it');
               });
            }
        }).error(function(err){});
    }

    //answer rating

    $scope.answerrating=function(rate,dissid,title,docname)
    {
        $http.get(APIUrl +'/evaidya_api/checklikes/answers/rating/'+dissid).success(function(data)
        {
           if(data=="Allowed")
           {
                $http.put(APIUrl +'/evaidya_api/answerrating/' +dissid+'/'+rate).success(function (data) {
                    $scope.bindall();
                    $scope.addengagement(dissid,title,"Answer","1","rated",docname);
                    console.log("From Rating Patient ID:"+$scope.uname+"DoctorId:"+data.username+"Discussion Id:"+data._id);
                    messageService.sendDiscussionRating($scope.uname,docname,data._id);
                }). error(function(error){

                    });
           }
           else
            {
               $ionicPopup.alert({
               title: 'Notice!',
               content: 'You already rated for this Q&A, Wait for 24 Hrs to change it'
               }).then(function(res) {
               console.log('You already rated for this Q&A, Wait for 24 Hrs to change it');
               });
            }
        }).error(function(err){});
    }

    $scope.discussUser = function (username) {

        if (username !== undefined) {
            var  pos = username.indexOf("@");//checking @ symbol in Q&A username

            if(pos!=-1)//if username is like his email then split "@" symbol
            {
                var usrname = username.split('@');
                return usrname[0];
            }
            else
            {
                return username;
            }
        }
        else
            return "";
    }
    var isNew = false;
    $scope.isEdit = false;

    //for open the form when doctor clicks on edit button
    $scope.edit = function (i) {
        $scope.isEdit = true;
        $scope.replyCount = i;
    }

    //for removing spam questions
    $scope.x = Math.floor((Math.random() * 6) + 1);
    $scope.y = Math.floor((Math.random() * 6) + 1);
    $scope.captcha = function (x, y) {

        $scope.total = x + y;
        return $scope.total;

    }


    $scope.rev_captcha = "";//for captcha to remove spam messages

    var title= $stateParams.id.replace(/-+/g, ' ');//getting title and replace - with space

    $scope.bindall=function()
    {
        if ($stateParams.id != -1) {

            //here checking title is in discussion list or not if it is found loop will be break
            //here we are checking title with ? because some titles are ending with ? so we are checking with both non question-mark and question-mark

            $http.get(APIUrl +'/evaidya_api/discussions/' + $stateParams.id).success(function(data){
                // shallow copy the object
                $scope.discussionData = data;
                $scope.cur_QA=$scope.discussdetail($scope.discussionData.title);
             


                var index = 0;
                if ( (data.category != null) && (data.category.trim().length != 0) ) {
                    index = $scope.docSpeciality.indexOf(data.category);
                    if (index < 0) {    // the db had some junk or discontinued category, we don't want it anymore
                        index = 0;
                    }
                }
                $scope.discussionData.category = $scope.docSpeciality[index];

                if (index == 0) {
                    $scope.discussionData.categoryReadOnly = 'None';
                } else {
                    $scope.discussionData.categoryReadOnly = $scope.discussionData.category;
                }


                discussionsData.getRepliesList($scope.discussionData._id).then(function (data) {
                    var repliesList = data;
                    $.each(repliesList, function (j, el) {
                        var name=el.username;

                        $http.get(APIUrl +'/evaidya_api/doctors/' +name).success(function (data) {
                            el.docname=data.name;
                            el.image=HOMEUrl+"/" + data.image;
                            el.Specialisation=data.speciality[0];
                            el.id=data._id;
                            el.docrating=data.rating;

                            //alert(e1.image) ;
                        }). error(function(error){

                            });
                        el.replied = new Date(el.replied);
                        el.modified = new Date(el.modified);
                        el.created = new Date(el.created);
                    });
                    // sort - very important
                    repliesList.sort(function (el1, el2) {
                        return (el2.replied > el1.replied) ? 1 : ( (el1.replied > el2.replied) ? -1 : 0 );
                    });
                    $scope.repliesList = repliesList;
                }, function (response) {
                    console.log(response);
                });

                //for SEO friendly URL's
                $scope.discussdetail=function(title)
                {
                    if(title !== undefined)
                    {
                        var lTitle= title.replace(/\s+/g, '-');//here  discussion tile replacing space with '-'
                        return lTitle;
                    }
                }

                //for increasing hits
                $scope.discussionData.hits = $scope.discussionData.hits + 1;
                discussionsData.hits($scope.discussionData.hits,$scope.discussionData._id);
                
                  $scope.noMoreItemsAvailable=true;//for loading button
     			$scope.$broadcast('scroll.infiniteScrollComplete');
            }). error(function(error){

                });;
        }
        else if ($stateParams.id === "-1") {
            $scope.discussionData = {
                title: "", created: new Date(), modified: new Date(), replied: new Date(), published: true, content: "", category: "", vote: 0, hits: 0, isresolve: false, answered: 0, parent_id: 0, num_likes: 0, tags: [], username: $scope.getUserName()};
            isNew = true;
        }

    }




    $scope.bindall();


    //To create new discussion
    $scope.save = function () {
        if (isNew) {
            var res=undefined;
            $scope.sys_capcha = ""; // dont need it for mobile
            $scope.discussionData.selectedSpeciality=$scope.selectedSpeciality;
            if ($scope.sys_capcha != $scope.rev_captcha)// here we are checking system value and user entered value
                $scope.errorMsg="Please Enter Correct Value";
            else if($scope.discussionData.title.length<1)
                $scope.errorMsg="Please enter title";

            else if ( $scope.discussionData.content.length<1)
                $scope.errorMsg="Please enter detailed information";
            else {
                
                
                 $ionicPopup.confirm({
              title: 'Are you sure!!!',
              content: 'The question that you just submitted is visible to the public in Health Forum. Do you want to continue??'
            }).then(function(res) {
              if(res) {
                discussionsData.discussions.save({uname: $scope.uname}, $scope.discussionData, function (event) {
                            discussionsData.discussionList = null; // clear discussionList
                            $scope.$back();
                        },
                        function (response) {
                        });
              } else {
                console.log('You are not sure');
              }
            });
                
                
                
                
                
                
                /*var result = window.confirm("The question that you just submitted is visible to the public in Health Forum. Do you want to continue?");
//                window.confirm("This  Question is public,Qusetion will published on site Do you want to continue? To make private Buy Plan <a href='/health-plans.html#!/pricingtable'>Here</a>", function(result) {
                if(result)
                {
                    discussionsData.discussions.save({uname: $scope.uname}, $scope.discussionData, function (event) {
                            discussionsData.discussionList = null; // clear discussionList
                            $scope.$back();
                        },
                        function (response) {
                        });

                }
//                });*/
                

            }
        }
        else {
        }
    };


    // for doctor reply
    $scope.post = function (content) {

        $scope.sys_capcha = ""; // dont need it for mobile


        if (!content) {
            $ionicPopup.alert({
               title: 'Notice!',
               content: 'Please give your reply'
               }).then(function(res) {
               console.log('Please give your reply');
               });
        }
        else {
            $scope.discussions = {
                title: $scope.discussionData.title, created: new Date(), modified: new Date(), replied: new Date(), published: true, visible: "NEEDS_APPROVAL", content: content, category: "", vote: 0, hits: 0, isresolve: true, answered: 1, parent_id: 0, num_likes: 0, tags: [], username: $scope.getUserName()};

            $scope.discussions.content = content;
            $scope.discussions.parent_id = $scope.discussionData._id;
            $scope.discussions.answered = $scope.repliesList.length + 1;

            $scope.discussionData.email = eVaidyaCache.userEmail();
            $ionicPopup.alert({
               title: 'Notice!',
               content: 'your answer will be review before publishing by eVaidya Team'
               }).then(function(res) {
               
               });
            


            discussionsData.discussions.update({uname: $scope.uname}, $scope.discussions, function (event) {
                    discussionsData.discussionList = null; // clear discussionList

                },
                function (response) {
                });
            $scope.$back();
        }

    };

    //when doctor want to deit his own discussion
    $scope.editReply = function (discussion) {
        $http.put(APIUrl +'/evaidya_api/discussions/edit/:$scope.userType', discussion).success(function (data) {
            console.log("Your reply modified");
        }).error(function (err) {
                console.log(err);
            })
        $scope.$back();

    }

    //Delete the Discussion Item
    $scope.deleteItem = function (discussion, listIndex) {

        discussionsData.discussions.delete({uname: $scope.uname, id: discussion._id, parentID: discussion.parent_id, replies: $scope.repliesList.length - 1}, function () {
                $scope.repliesList.splice(listIndex, 1);
            },
            function (response) {
            });
    };


    $scope.saveCategory = function(id, category) {
        $http.post(APIUrl +'/evaidya_api/updateQuestionCategory/' + id,{params: {category: category}}).success(function(data){
        }).error(function(error) {
            });
    }


    //for seo perspective add meta-keywords and meta-description
    $scope.metaSave=function()
    {
        $scope.discussions=$scope.discussionData;
        $scope.discussions.meta_keyword=$scope.discussionData.meta_keyword;
        $scope.discussions.meta_description=$scope.discussionData.meta_description;
        if(!$scope.discussions.meta_description)//if meta description is not given then it can be set to empty
            $scope.discussions.meta_description="";


        discussionsData.discussions.update({uname: $scope.uname}, $scope.discussions, function (event) {
                discussionsData.discussionList = null; // clear discussionList

            },
            function (response) {
            });
        $scope.$back();

    }
    $rootScope.imageload=false;

}]);
