'use strict';
evaidyaApp.controller('DoctorListCtrl',
    ['$scope', 'doctorData', 'membershipsData','$location', 'eVaidyaCache', '$rootScope','$stateParams','$ionicPopup','$ionicLoading','$ionicPlatform',function DoctorListCtrl($scope, doctorData, membershipsData,$location, eVaidyaCache,$rootScope,$stateParams,$ionicPopup,$ionicLoading,$ionicPlatform) {

        $scope.user= profileusername;
        $scope.APIURL=APIUrl+'/';
        $scope.noMoreItemsAvailable=false;//for loading button
        
       

        $scope.profileusername="Welcome <b>"+profileusername+"</b>";
        $scope.itemButtons = [
        {
            text: 'Phone',
            type: 'button-assertive',
            onTap: function(item) {
                $scope.setSelectedDoc(item,'Phone'); 
             var hashpath = "/evaidya/consult/"+item.username;
                $location.path(hashpath);
            }
        },
        {
            text: 'Message',
            type: 'button-calm',
            onTap: function(item) {
                $scope.setSelectedDoc(item,'Message');  
               var hashpath = "/evaidya/consult/"+item.username;
                $location.path(hashpath);
            }
        }
    ];
        
          

        $scope.dislimit=function(note)
        {
            var limitnote=note;
            if(note.length>23)
            {
                limitnote= note.substring(0,23)+"..." ;
            }
            return limitnote;
        }
        //$scope.limit = "10";
        $scope.selectedSpeciality = "";
        $scope.selectedLanguage = "";
        $scope.docSpeciality = [];
        $scope.langaugesSpoken = [];
        $scope.familymsg=false;//ask them to consult only family doctors

        //checking if user having access to speciality otherwise show eVaidya family Doctors as a first priority
        if(!$scope.isKiosk && $scope.uname)
        {
                membershipsData.checkAccess('Specialist','250').then(function(res)
                {

                    if(res != "Approved")
                    {
                        //$scope.selectedSpeciality="Family Practice";
                        $scope.familymsg=true;
                    }

                })
        }
        $scope.currentDoc = {};
        var langDupes = {};
        var specDupes = {};

        $scope.docList = eVaidyaCache.docList();
        
        if($scope.docList)
        {
             $scope.noMoreItemsAvailable=true;//for loading button
     		$scope.$broadcast('scroll.infiniteScrollComplete');
        }


        if(!$scope.docList)
        {
            doctorData.getDoctorList().then(function(docList)
            {
                $scope.docList = docList;
                $scope.populateFlds();
                
                  $scope.noMoreItemsAvailable=true;//for loading button
     			$scope.$broadcast('scroll.infiniteScrollComplete');
            },function(response){ console.log(response);});

        }
        $scope.setSelectedDoc= function(doc,consulttype) {
                if(doc)
                    eVaidyaCache.setSelectedDoc (doc); // store the state
                eVaidyaCache.consultationCurrentSheet = 0;
            eVaidyaCache.evCache.put("consulttype",consulttype);
               var hashpath = "/evaidya/consult/"+doc.username;
                $location.path(hashpath);

            eVaidyaCache.evCache.put("redirect", "/consult/"+ doc.username); // incase of redirect
        }

        // To rset the doctor list //
        // $scope.$watch('filterBySpeciality', function() {
        	
    	//});
        
        
        $scope.populateFlds = function()
        {
            if($scope.docList)
            {
                //$scope.docSpeciality.push("--Select--");
            jQuery.each($scope.docList, function (i, el) {
                        jQuery.each(el.languagesKnown, function (j, el1) {
                            if (el1 !== '' && !langDupes[el1]) {
                                langDupes[el1] = true;
                                $scope.langaugesSpoken.push(el1);
                            }
                        });
                        jQuery.each(el.speciality, function (j, el2) {
                            if (el2 !== '' && !specDupes[el2]) {
                                specDupes[el2] = true;
                                if ($scope.docSpeciality.indexOf(el2) == -1) {
                                    $scope.docSpeciality.push(el2);
                                }
                               // $scope.docSpeciality.push(el2);
                            }
                        });
                    });
                
                    $scope.selectedSpeciality = $scope.docSpeciality[0];
                    $scope.selectedLanguage = $scope.langaugesSpoken[0];
             }
        };

        // Filters
        /*$scope.filterBySpeciality = function (doc) {
            var retValFltr = false;
            
           
            jQuery.each(doc.speciality, function (j, el) {
                
               

                if($scope.selectedSpeciality==="--Select--")
                {
                    
                           retValFltr=true;
                }
                if ($scope.selectedSpeciality === el)
                	                  retValFltr = true;
            });
            return retValFltr;
        };*/

        $scope.filterByLanguages = function (doc) {
            var retValFltr = false;
            jQuery.each(doc.languagesKnown, function (j, el) {
                if ($scope.selectedLanguage === el)
                    retValFltr = true;
            });
            return retValFltr;
        };
        $scope.populateFlds();

//for seo friendly URL's
        $scope.doctorDetails=function(name)
        {


                name= name.replace(/\s+/g, '-');//  doctor name replacing space with '-'
                return name;



               // $location.url('/404.html');


        }

        //for displaying all doctors in customercare
        $scope.docName="";
        $scope.status=["Enable","Disable"];
        $scope.selectedStatus="Enable";

        doctorData.getAllDoctors($scope.docName).then(function(data)
        {
            $scope.doctorsList=data;
        });

        $scope.disableDoc=function(doctor)
        {
            doctorData.DisableDoctor(doctor);
            doctor.ispublish=false;
        }
        $scope.enableDoc=function(doctor)
        {

              doctorData.EnableDoctor(doctor);
              doctor.ispublish=true;
        }

        $rootScope.imageload=false;


        if( $stateParams.city!==undefined)
        {
            if($stateParams.city=='')
            {
                $scope.city='';
            }
            else
            {
            $scope.city=$stateParams.city;
            }
        }
        if( $stateParams.speciality!==undefined)
        {
            if($stateParams.speciality=='')
            {
                $scope.selectedSpeciality="--Select--";
            }
            else
            {
                $scope.selectedSpeciality=$stateParams.speciality;
            }
        }
    }]);

evaidyaApp.controller('DoctorDetailCtrl',
    [ '$scope','$http', '$location', '$stateParams', 'doctorData','eVaidyaCache','$rootScope','$ionicPopup','$ionicPlatform', function DoctorDetailCtrl($scope,$http, $location, $stateParams, doctorData,eVaidyaCache,$rootScope,$ionicPopup,$ionicPlatform) {
        $scope.APIURL=APIUrl+'/';
		$scope.noMoreItemsAvailable=false;//for loading button
        
      

         $scope.views=function(id)
          {

             $http.put(APIUrl+'/evaidya_api/doctorprofileview/'+id).success(function(data){

                 $scope.view=data;
             }).error(function(error){});

           }



        $scope.addengagement=function(id,title,type,notification,notifytype,ownerby)
        {
            $http.post(APIUrl+'/evaidya_api/doctorengagement',{param:{id:id,title:title,type:type,notification:notification,notifytype:notifytype,ownerby:ownerby}}).success(function(data){


            }).error(function(error){})
        }


   $scope.docrating=function(rate,docid)
        {

            $http.get(APIUrl+'/evaidya_api/checklikes/profile/rating/'+docid).success(function(data){

                if(data=="Allowed")
                {


                    $http.put(APIUrl+'/evaidya_api/rating/' +docid+'/'+rate).success(function (data) {

                        $scope.addengagement($scope.docData._id,$scope.docData.name,"Profile","1","rating",$scope.docData.username);



                        $scope.calculaterating(data.rating);

                    }). error(function(error){

                        });

                }
                else
                {

                   $ionicPopup.alert({
               title: 'Notice!',
               content: 'You already rated for this Doctor, Wait for 24 Hrs to change it'
               }).then(function(res) {
               
               });

                }


            }).error(function(error){});



        }


           $scope.calculaterating=function(rating)
        {
            $scope.rate3="ion ion-ios7-star-outline";
            $scope.rate4="ion ion-ios7-star-outline";
            $scope.rate5="ion ion-ios7-star-outline";
               for(var i=0;i<=rating;i++) {

                if(i==3)
                {
                    $scope.rate3="ion-ios7-star";
                }
                if(i==4)
                {
                    $scope.rate4="ion-ios7-star ";
                }
                if(i==5)
                {
                    $scope.rate5="ion-ios7-star ";
                }
            }
           }



        doctorData.getDoctor($stateParams.id).then(function(docData)
        {
            var defatultrate="";
            $scope.docData = docData ;
            $scope.likes=docData.likes;
            $scope.rating=docData.rating;
            $scope.view=docData.views;

            $scope.views($scope.docData._id);
            $scope.addengagement($scope.docData._id,$scope.docData.name,"Profile","1","View",$scope.docData.username);
            $scope.calculaterating($scope.rating);
            
            
            $scope.noMoreItemsAvailable=true;//for loading button
     	   $scope.$broadcast('scroll.infiniteScrollComplete');


            //for SEO friendly URL's
            $scope.discussdetail=function(title)
            {

                var title= title.replace(/\s+/g, '-');//here  discussion tile replacing space with '-'
                return title;
            }

            


            if($scope.isAdmin)
            {
                $http.get(APIUrl+'/evaidya_api/customercare/doctors/' + docData.username).success(function (data) {

                    $scope.email=data.email;
                    $scope.phone=data.phone;
                }). error(function(error){

                    });

            }

        });
          $scope.setSelectedDoc= function(doc,consulttype) {
                if(doc)
                    eVaidyaCache.setSelectedDoc (doc); // store the state
                eVaidyaCache.consultationCurrentSheet = 0;
            eVaidyaCache.evCache.put("consulttype",consulttype);

            eVaidyaCache.evCache.put("redirect", "/consult/"+ doc.username); // incase of redirect
        }


        $scope.metaSave=function()
        {
           doctorData.updateDoctorProfile($scope.docData);
            $scope.$back();
        }
      
        $scope.dislimit=function(note)
        {
            var limitnote=note;
            if(note.length>23)
            {
                limitnote= note.substring(0,23)+"..." ;
            }
            return limitnote;
        }

        $rootScope.imageload=false;
    }]);

evaidyaApp.controller('DoctorConsultCtrl',
    [ '$scope', '$location', '$stateParams', 'eVaidyaCache','membershipsData','$rootScope' ,function DoctorConsultCtrl($scope, $location, $stateParams, eVaidyaCache, membershipsData,$rootScope) {

                         $scope.msgemail=false;
                         $scope.checkdate=function(id)
                         {
                             var  one = new Date(),
                                 two = new Date(id);
                             var millisecondsPerDay = 1000 * 60 * 60 * 24;
                             var millisBetween = two.getTime() - one.getTime();
                             var days = millisBetween / millisecondsPerDay;

                             if(Math.floor(days)>=7||Math.floor(days)<0)
                             {
                                 $scope.msgemail=true;



                             }
                             else
                             {
                                 $scope.msgemail=false;
                             }

                         }
        $scope.profileusername="Welcome <b>"+profileusername+"</b>";
        $scope.docData = eVaidyaCache.findDoc($stateParams.id);
        $rootScope.imageload=false;
    }]);

evaidyaApp.controller('editDoctorCtrl',
    [ '$scope','$http', '$location', '$stateParams','doctorData','eVaidyaCache','filesData','$rootScope', function editDoctorCtrl($scope,$http, $location, $stateParams, doctorData,eVaidyaCache,filesData,$rootScope) {
        $scope.APIURL=APIUrl+'/';
        $scope.doctor="";
        $scope.docSpeciality = ["Laparoscopic Surgeon","Surgical Gastroenterologist","Bariatric Surgeon","Diabetologist/ Sugar Specialist","Psychiatrist","Psychologist","Dermatologist","Physiotherapist","Family Practice","Neurosurgeons","Oncologist/ Cancer Specialist","Pediatrician / Children specialist","Gynaecologist & Obstetrician","Urologist/ Kidney Specialist","Ayurveda","Plastic surgeon","Sexologist","Ophthalmologist","Orthopaedist/ Bone Specialist","Rheumatologist/Joint specialist","General Medicine","General Surgeon","Dietician / Nutritionist","Cardiologist/ Heart specialist","Dentists","Homeopathy","Endocrinologist","Endocrine Surgeon","Gastroenterologist","Paediatric surgeon","Pulmonologist/Lung specialist","Anesthesiologist","ENT / Ear Nose throat specialist","HIV specialist","Nuclear Medicine","Pain Specialist","Emergency Physicians","Nephrologist/ Kidney Specialist","Internal Medicine","Hemotologists","Neurologist","Pathologists","Spine surgeon","Pediatric Neurologist"];
        $scope.langaugesSpoken = ["English","Hindi","Gujarati","Sindhi","Marathi","Tamil","Urdu","Telugu","Bengali","Kannada","Punjabi","Rajastani","Arabic","French","German","Kutchi","Tulu","Malayalam","Oriya","Nepali"];
        $scope.qualification=["MBBS","MD","MDDM"];
        $scope.errorMsg="";

        //to upload doctor Image

        $scope.fileToken = new Date().getTime();
        $scope.getFileInfo = function(e) {
            return $.map(e.files, function(file) {
                var info = file.name;

                // File size is not available in all browsers
                if (file.size > 0) {
                    info  += " (" + Math.ceil(file.size / 1024) + " KB)";
                }
                return info;
            }).join(", ");
        }



        var filename=[];
        $scope.onUpload = function(event) {
            //storing file name in cache for storing filename in consultation schema
            filename.push($scope.fileToken+event.files[0].name);

            eVaidyaCache.setFileName( filename);
            event.data = {username: $scope.uname, fileToken: $scope.fileToken,   kiosk: $scope.kioskName};
        }



        $scope.onRemove = function(event) {
            event.data = {username: $scope.uname, fileToken: $scope.fileToken, kiosk: $scope.kioskName};
        };

        $scope.onComplete = function(event) {
            filesData.filesList = null; // clear the cache in service
        };

        $scope.uploadOptions =   {
            async: {
                saveUrl: "/evaidya_api/upload/doctors",
                removeUrl: "/evaidya_api/doctors/deleteuploaded",
                autoUpload: true
            },
            remove: $scope.onRemove,
            upload: $scope.onUpload,
            complete: $scope.onComplete
        };




        doctorData.getDoctor($stateParams.DocID).then(function(docData)
        {
            $scope.doctor = docData ;
            if($scope.isAdmin)
            {
                $http.get(APIUrl+'/evaidya_api/customercare/doctors/' + docData.username).success(function (data) {

                    $scope.email=data.email;
                    $scope.phone=data.phone;
                }). error(function(error){

                    });

            }


        });
        $scope.updateDoctor=function()
        {
            if( eVaidyaCache.selectFileName()!="")//if doctor image is modified then update image
            {

            $scope.doctor.image="images/avatar/"+eVaidyaCache.selectFileName();// file name from cache
            }
            else
            {
                $scope.doctor.image=$scope.doctor.image; //?? not sure what this
            }

                doctorData.updateDoctorProfile($scope.doctor);
            eVaidyaCache.setFileName(""); //clear file Name
            $scope.$back();

        }
        $rootScope.imageload=false;
    }]);


//The controller functionality required for the Doctor Dashboard feature
evaidyaApp.controller('DoctorDashboardCtrl',
    ['$scope', '$http', '$location', '$stateParams','$ionicPopup','$rootScope', function DoctorDashboardCtrl($scope, $http, $location, $stateParams,$ionicPopup,$rootScope) {

    // <start> -- new additions for the new UI
    var uname = $scope.uname;
         $scope.doctor={amtPerConsultation:0};
        
              $scope.noMoreItemsAvailable=false;//for loading button
     		
        
        //check rating to display

    $scope.checkrating=function(rate,original)
    {
        if(rate<=original)
        {
            return "ion-ios7-star";
        }
        else
        {
            return "ion-ios7-star-outline";
        }
    }
        
	
        $scope.getpaymentDetails = function(callback){
         
            $http.get(APIUrl+'/evaidya_api/doctors/'+uname).success(function(data){
             	$scope.doctor = data;
                 $scope.noMoreItemsAvailable=true;//for loading button
         		$scope.$broadcast('scroll.infiniteScrollComplete');
            
            
                 if (data.speciality.length == 1 ? data.speciality[0] === 'Family Practice' : true)
                    {
                        $scope.doctor.amtPerConsultation = 50;
                     } 
                    else
                    {
                        $scope.doctor.amtPerConsultation = 150;
                     }
               
                callback(null, $scope.doctor.amtPerConsultation);
                   
            }).error(function(error){ console.log(error); callback(error, null)});
    
            
        }
          
                        
       
    // for the head part
    
      
        
        




    // for the Payments part
    $http.get(APIUrl+'/evaidya_api/doctorDashboardPaymentSummary/'+uname).success(function(data){
         //$scope.username = data.username;
         //$scope.doctorName = data.name;
        $scope.getpaymentDetails(function(err, payDetails){
         
            $scope.payableConsultations = data.length;
	        $scope.payableAmtPerConsultation=payDetails;
    	   
      
      	   $scope.payableAmount = data.length * ($scope.payableAmtPerConsultation);
        

        })
             }).error(function(error){});

    $scope.viewAmount=function() {
        
        $ionicPopup.alert({
               title: 'Notice!',
               content: 'Your current amount is Rs.' + $scope.payableAmount +'/-'
               }).then(function(res) {
               console.log('Your current amount is '+$scope.payableAmount);
               });
    }

    $scope.withdraw=function()
    {
        if ($scope.payableAmount < 1000 ) {
           
             $ionicPopup.alert({
               title: 'Notice!',
               content: 'Sorry, you need to accrue Rs.1000/- before you can withdraw. Your current amount is Rs.' + $scope.payableAmount +'/-'
               }).then(function(res) {
               console.log('Sorry, you need to accrue Rs.1000/- ');
               });
        } else {
            var emailMesg = "Please process a doctor payment request  with these details: Doctor Name:" + $scope.doctorName
                    + ", Doctor Username:" + $scope.username
                    + ", # of Payable Consultations:" + $scope.payableConsultations
                    + ", Amount: Rs." + $scope.payableAmount + "/-";

            
            $ionicPopup.alert({
               title: 'Notice!',
               content: 'We will process your withdrawal request within 3 business days. Please contact 1800 1030 365 for further clarifications.'
               }).then(function(res) {
               console.log('We will process your withdrawal request within 3 business days. Please contact 1800 1030 365 for further clarifications.');
               });
            

            /*$http.post(APIUrl+'/evaidya_api/doctorDashboardPaymentWithdraw/'+$rootScope.uname, {param:{emailMesg: emailMesg}}).success(function(data){
                alert ("Successfully triggered your payment request!");
            }).error(function(error){});*/
        }
    }

    }]);
