'use strict';
evaidyaApp.controller('ImmunizationsListCtrl',['$scope', '$location', '$ionicPopup', 'immunizationsData', 'eVaidyaCache', function ImmunizationsListCtrl($scope, $location,$ionicPopup, immunizationsData, eVaidyaCache) {
    $scope.viewOnly = false;
    $scope.showSelected = false;

    $scope.itemButtons = [
        {
            text: 'Delete',
            type: 'button-assertive',
            onTap: function(item) {
                $scope.deleteItem(item);            }
        },
        {
            text: 'Edit',
            type: 'button-calm',
            onTap: function(item) {
                var hashpath = "/evaidya/immunizationsdetail/"+ item;
                $location.path(hashpath);
            }
        }
    ];

    immunizationsData.populateStaticList();
    $scope.dislimit=function(note)
    {
        var limitnote=note;
        if(note.length>20)
        {
            limitnote= note.substring(0,20) ;
        }
        return limitnote;
    }
    if(immunizationsData.uname === $scope.uname && immunizationsData.immunizationsList )
        $scope.immunizationsList =  immunizationsData.immunizationsList;
    else
    {
        immunizationsData.getImmunizationsList().then(function(immunizationsList){
            $scope.immunizationsList = immunizationsList;
            immunizationsData.immunizationsList = immunizationsList;
            immunizationsData.uname = $scope.uname;
        }, function(response){ console.log(response);});
    }

    $scope.deleteItem  = function (listIndex) {
        $ionicPopup.confirm({
            title: 'Delete Immunization Record?',
            content: 'Are you sure you want to delete?'
        }).then(function(res) {
                if(res) {
                    $scope.immunizationsList = immunizationsData.immunizationsList;
                    immunizationsData.immunizations.delete({uname:$scope.uname,id:$scope.immunizationsList[listIndex]._id},function () {
                            $scope.immunizationsList.splice(listIndex, 1);
                        },
                        function (response) {
                        });
                } else {
                }
            });
    };
}]);

evaidyaApp.controller('ImmunizationsDetailCtrl', ['$scope', '$location', '$stateParams','$filter', 'immunizationsData', 'eVaidyaCache', function ImmunizationsDetailCtrl($scope, $location, $stateParams,$filter, immunizationsData, eVaidyaCache) {
    var isNew = false;
    $scope.immunizationsStaticList = eVaidyaCache.immunizationsStaticList();
    immunizationsData.getImmunizationsList().then(function(immunizationsList){
        $scope.immunizationsList = immunizationsList;
        immunizationsData.immunizationsList = immunizationsList;
    if($stateParams.id >= 0)
    // shallow copy the object
        $scope.immunizationsData = jQuery.extend({}, $scope.immunizationsList[$stateParams.id]);
    else if($stateParams.id === "-1")
    {
        $scope.immunizationsData = {OccurDate:new Date()
            , Vaccine: ""
            , Note: ""
            ,patientId: $scope.getUserName()};
        isNew = true;
    }
    else // clone the first element
    {
        $scope.immunizationsData = jQuery.extend({}, $scope.immunizationsList[0]);
        isNew = true;
    }
    $scope.immunizationsData.OccurDate = $filter("date")($scope.immunizationsData.OccurDate, 'yyyy-MM-dd');
    });
    $scope.save  = function () {
        if(isNew)
        {
            immunizationsData.immunizations.save({uname: $scope.uname},$scope.immunizationsData,function (event) {
                    event.OccurDate = new Date(event.OccurDate);
                    immunizationsData.immunizationsList.push(event);
                    // sort - very important
                    immunizationsData.immunizationsList.sort(function (el1, el2) {
                        return (el2.OccurDate > el1.OccurDate) ? 1 : ( (el1.OccurDate > el2.OccurDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
        }
        else
            immunizationsData.immunizations.update({uname: $scope.uname},$scope.immunizationsData,function (event) {
                    event.OccurDate = new Date(event.OccurDate);
                    jQuery.each(immunizationsData.immunizationsList, function (j, el) {
                        if (event._id === el._id) {
                            immunizationsData.immunizationsList[j] = event;
                            return false; // break the loop
                        }
                    });
                    // sort - very important
                    immunizationsData.immunizationsList.sort(function (el1, el2) {
                        return (el2.OccurDate > el1.OccurDate) ? 1 : ( (el1.OccurDate > el2.OccurDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
    };

}]);
