'use strict';
evaidyaApp.controller('LipidProfileListCtrl',['$scope','$window',  'lipidProfileData', 'eVaidyaCache', function LipidProfileListCtrl($scope,$window,  lipidProfileData, eVaidyaCache) {
    $scope.viewOnly = false;
    $scope.showSelected = false;
    if(lipidProfileData.uname === $scope.uname && lipidProfileData.lipidProfileList )
        $scope.lipidProfileList =  lipidProfileData.lipidProfileList;
    else
    {
        lipidProfileData.getlipidProfileList().then(function(lipidProfileList){
            $scope.lipidProfileList = lipidProfileList;
            lipidProfileData.lipidProfileList = lipidProfileList;
            lipidProfileData.uname = $scope.uname;
        }, function(response){ console.log(response);});
    }

    $scope.deleteItem  = function (listIndex) {
        var result = window.confirm("Are you sure want to delete this item?");
            if(result==true)
            {
        //$scope.lipidProfileList[listIndex]
        $scope.lipidProfileList = lipidProfileData.lipidProfileList;
        lipidProfileData.lipidProfile.delete({uname:$scope.uname,id:$scope.lipidProfileList[listIndex]._id},function () {
                $scope.lipidProfileList.splice(listIndex, 1);
            },
            function (response) {});
        }
        else
        {

        }
    };
}]);

evaidyaApp.controller('LipidProfileDetailCtrl', ['$scope', '$location', '$routeParams','lipidProfileData', 'eVaidyaCache',function LipidProfileDetailCtrl($scope, $location, $routeParams,lipidProfileData, eVaidyaCache) {
    $scope.lipidProfileList = lipidProfileData.lipidProfileList;
    $scope.severityValues= ["Severe","Moderate","Mild"];
    var isNew = false;
    lipidProfileData.getlipidProfileList().then(function(lipidProfileList){
        $scope.lipidProfileList = lipidProfileList;
        lipidProfileData.lipidProfileList = lipidProfileList;
    if($routeParams.id >= 0)
    // shallow copy the object
        $scope.lipidProfileData = jQuery.extend({}, $scope.lipidProfileList[$routeParams.id]);
    else if($routeParams.id === "-1")
    {
        $scope.lipidProfileData = {measureDate:new Date()
            , HDL: 27
            , LDL: 100
            , VLDL: 20
            , triglycerides: 100
            , totalChol: 127
            , cholHDLRatio: 4.7
            ,patientId: $scope.getUserName()};
        isNew = true;
    }
    else // clone the first element
    {
        $scope.lipidProfileData = jQuery.extend({}, $scope.lipidProfileList[0]);
        isNew = true;
    }
    });
    $scope.$watch('lipidProfileData.HDL + lipidProfileData.LDL', function (value) {
        if( $scope.lipidProfileData)
        $scope.lipidProfileData.totalChol = value;
    });
    $scope.$watch('(lipidProfileData.HDL + lipidProfileData.LDL)/lipidProfileData.HDL', function (value) {
        if($scope.lipidProfileData)
        $scope.lipidProfileData.cholHDLRatio = value.toFixed(2);
    });

    $scope.save  = function () {
        if(isNew)
        {
            lipidProfileData.lipidProfile.save({uname: $scope.uname},$scope.lipidProfileData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                    lipidProfileData.lipidProfileList.push(event);
                    // sort - very important
                    lipidProfileData.lipidProfileList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
        }
        else
            lipidProfileData.lipidProfile.update({uname: $scope.uname},$scope.lipidProfileData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                    jQuery.each(lipidProfileData.lipidProfileList, function (j, el) {
                        if (event._id === el._id) {
                            lipidProfileData.lipidProfileList[j] = event;
                            return false; // break the loop
                        }
                    });
                    // sort - very important
                    lipidProfileData.lipidProfileList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
    };

}]);

