    'use strict';
evaidyaApp.controller('MedicationsListCtrl',['$scope', '$location', '$ionicPopup', 'medicationsData', 'eVaidyaCache', function MedicationsListCtrl($scope, $location,$ionicPopup, medicationsData, eVaidyaCache) {
    $scope.viewOnly = false;
    $scope.showSelected = false;
    $scope.itemButtons = [
        {
            text: 'Delete',
            type: 'button-assertive',
            onTap: function(item) {
                $scope.deleteItem(item);            }
        },
        {
            text: 'Edit',
            type: 'button-calm',
            onTap: function(item) {
                var hashpath = "/evaidya/medicationsdetail/"+ item;
                $location.path(hashpath);
            }
        }
    ];


    medicationsData.populateStaticList();
    if(medicationsData.uname === $scope.uname && medicationsData.medicationsList )
        $scope.medicationsList =  medicationsData.medicationsList;
    else
    {
            medicationsData.getMedicationsList().then(function(medicationsList){
                $scope.medicationsList = medicationsList;
                medicationsData.medicationsList = medicationsList;
                medicationsData.uname = $scope.uname;
        }, function(response){ console.log(response);});
    }

    $scope.dislimit=function(note)
    {
        var limitnote=note;
        if(note.length>20)
        {
            limitnote= note.substring(0,20) ;
        }
        return limitnote;
    }
    $scope.setSelected = function(list){

    };
    $scope.clearSelected = function() {

    };
    $scope.deleteItem  = function (listIndex) {
        $ionicPopup.confirm({
            title: 'Delete condition?',
            content: 'Are you sure you want to delete?'
        }).then(function(res) {
                if(res) {
                        $scope.medicationsList = medicationsData.medicationsList;
                        medicationsData.medications.delete({uname:$scope.uname,id:$scope.medicationsList[listIndex]._id},function () {
                                $scope.medicationsList.splice(listIndex, 1);
                        },
                        function (response) {
                        });
                } else {
                }
            });
    };
}]);

evaidyaApp.controller('MedicationsDetailCtrl', ['$scope', '$location', '$stateParams','$filter', 'medicationsData', 'eVaidyaCache', function MedicationsDetailCtrl($scope, $location, $stateParams, $filter, medicationsData, eVaidyaCache) {
    $scope.frequencyList = ["As Needed(p.r.n)", "Every Hour(q.h.)", "Every 4 hours(q.4h.)", "Once per day(q.d.)", "Twice a day(b.i.d.)", "Three times a day(t.i.d.)", "Every Other Day(q.o.d.)", "Every Week(QWK)", "In the Morning(a.m.)", "In the Evening(p.m.)", "At bedtime(h.s.)"];
    var isNew = false;
    $scope.medicationsStaticList = eVaidyaCache.medicationsStaticList();
    medicationsData.getMedicationsList().then(function(medicationsList){
        $scope.medicationsList = medicationsList;
        medicationsData.medicationsList = medicationsList;
    if ($stateParams.id >= 0)
    // shallow copy the object
        $scope.medicationsData = jQuery.extend({}, $scope.medicationsList[$stateParams.id]);
    else if ($stateParams.id === "-1") {
        $scope.medicationsData = {
            medicineName: "", Dosage: "", frequency: "As Needed(p.r.n)", supplementalInfo: "", specialInstruction: "", startDate: new Date(), stopDate: new Date(), isActive: true, patientId: $scope.getUserName(), consultationId: ""};
        isNew = true;
    }
    else // clone the first element
    {
        $scope.medicationsData = jQuery.extend({}, $scope.medicationsList[0]);
        isNew = true;
    }
        $scope.medicationsData.startDate = $filter("date")($scope.medicationsData.startDate, 'yyyy-MM-dd');
        $scope.medicationsData.stopDate = $filter("date")($scope.medicationsData.stopDate, 'yyyy-MM-dd');
    });
    $scope.save = function () {
        if (isNew) {
            medicationsData.medications.save({uname: $scope.uname}, $scope.medicationsData, function (event) {
                    event.measureDate = new Date(event.measureDate);
                    medicationsData.medicationsList.push(event);
                    // sort - very important
                    medicationsData.medicationsList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {
                });
        }
        else
            medicationsData.medications.update({uname: $scope.uname}, $scope.medicationsData, function (event) {
                    /*event.measureDate = new Date(event.measureDate);
                    jQuery.each(medicationsData.medicationsList, function (j, el) {
                        if (medicationsData.medicationsList._id === el._id) {
                            medicationsData.medicationsList[j] = event;
                            return false; // break the loop
                        }
                    });
                    // sort - very important
                    medicationsData.medicationsList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    */
                    event.measureDate = new Date(event.measureDate);
                    jQuery.each(medicationsData.medicationsList, function (j, el) {
                        if (event._id === el._id) {
                            medicationsData.medicationsList[j] = event;
                            return false; // break the loop
                        }
                    });
                    // sort - very important
                    medicationsData.medicationsList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {
                });


    }
}]);

    // This will add medication and save it to  both medications and consultations
    evaidyaApp.controller('DocMedicationsDetailCtrl',['$scope', '$location', '$stateParams','$filter', 'medicationsData','consultationsData', 'eVaidyaCache', function MedicationsDetailCtrl($scope, $location, $stateParams, $filter, medicationsData,consultationsData, eVaidyaCache) {
        var isNew = false;
        medicationsData.getMedicationsList().then(function(medicationsList){
            $scope.medicationsList =  eVaidyaCache.docCurrentConsultationData.medications;
        if ($stateParams.id >= 0)
        // shallow copy the object
            $scope.medicationsData = jQuery.extend({}, $scope.medicationsList[$stateParams.id]);
        else if ($stateParams.id === "-1") {
            $scope.medicationsData = {
                medicineName: "", Dosage: "", frequency: "", supplementalInfo: "", specialInstruction: "", startDate: new Date(), stopDate: new Date(), isActive: true, patientId:patient_id, consultationId: ""};
            isNew = true;
        }
        $scope.medicationsData.startDate = $filter("date")($scope.medicationsData.startDate, 'yyyy-MM-dd');
        $scope.medicationsData.stopDate = $filter("date")($scope.medicationsData.stopDate, 'yyyy-MM-dd');
        });
        $scope.docCurrentConsultationData = eVaidyaCache.docCurrentConsultationData;
        var patient_id = $scope.docCurrentConsultationData.patientId;
        $scope.frequencyList = ["As Needed(p.r.n)", "Every Hour(q.h.)", "Every 4 hours(q.4h.)", "Once per day(q.d.)", "Twice a day(b.i.d.)", "Three times a day(t.i.d.)", "Every Other Day(q.o.d.)", "Every Week(QWK)", "In the Morning(a.m.)", "In the Evening(p.m.)", "At bedtime(h.s.)"];
        //just in case populate static data
        medicationsData.populateStaticList();
        $scope.medicationsStaticList = eVaidyaCache.medicationsStaticList();

        $scope.save = function () {
            if (isNew) {
                medicationsData.medications.save({uname: $scope.uname}, $scope.medicationsData, function (event) {
                        //$scope.medicationsList.push(event);
                        // copy this into consultations and save
                        $scope.docCurrentConsultationData.medications.push({ medicineName: event.medicineName, Dosage: event.Dosage, frequency: event.frequency, supplementalInfo: event.supplementalInfo, specialInstruction: event.specialInstruction, startDate: event.startDate, stopDate: event.stopDate});
                        consultationsData.consultations.update({uname: $scope.uname}, $scope.docCurrentConsultationData, function (event){

                        },function (response) {

                        });
                        $scope.$back();
                    },
                    function (response) {
                        var test =1;
                    });


                //to insert in patient medication tab
                medicationsData.medications.save({uname: $scope.docCurrentConsultationData.patientId}, $scope.medicationsData, function (event) {
                        event.measureDate = new Date(event.measureDate);
                        medicationsData.medicationsList.push(event);
                        // sort - very important
                        medicationsData.medicationsList.sort(function (el1, el2) {
                            return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                        });
                        $scope.$back();
                    },
                    function (response) {
                    });

            }
            else
            {
                $scope.docCurrentConsultationData.medications[$stateParams.id]=$scope.medicationsData
                /* medicationsData.medications.update({uname: $scope.docCurrentConsultationData.patientId}, $scope.medicationsData, function (event) {
                 event.measureDate = new Date(event.measureDate);
                 jQuery.each(consultationsData, function (j, el) {
                 if (event._id === el._id) {
                 medicationsData.medicationsList[j] = event;
                 return false; // break the loop
                 }
                 });

                 // sort - very important
                 consultationsData.medica.sort(function (el1, el2) {
                 return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                 });
                 $scope.$back();
                 },*/
                medicationsData.medications.update({uname: $scope.uname}, $scope.medicationsData, function (event) {


                        // copy this into consultations and save
                        medicationsData.medications.update({uname: $scope.uname},{ medicineName: event.medicineName, Dosage: event.Dosage, frequency: event.frequency, supplementalInfo: event.supplementalInfo, specialInstruction: event.specialInstruction, startDate: event.startDate, stopDate: event.stopDate});
                        consultationsData.consultations.update({uname: $scope.uname}, $scope.docCurrentConsultationData, function (event){
                            event.measureDate = new Date(event.measureDate);
                            jQuery.each(medicationsData.medications, function (j, el) {
                                if (event._id === el._id) {
                                    medicationsData.medicationsList[j] = event;
                                    return false; // break the loop
                                }
                            });
                            // sort - very important
                            medicationsData.medicationsList.sort(function (el1, el2) {
                                return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                            });

                        },function (response) {

                        });
                        $scope.$back();
                    },
                    function (response) {
                    });
            }
        };

    }]);
