'use strict';
evaidyaApp.controller('SymptomsListCtrl',['$scope', '$location', '$ionicPopup', 'symptomsData', 'eVaidyaCache', function SymptomsListCtrl($scope,$location, $ionicPopup, symptomsData, eVaidyaCache) {
    $scope.itemButtons = [
        {
            text: 'Delete',
            type: 'button-assertive',
            onTap: function(item) {
                $scope.deleteItem(item);            }
        },
        {
            text: 'Edit',
            type: 'button-calm',
            onTap: function(item) {
                var hashpath = "/evaidya/symptomsdetail/"+ item;
                $location.path(hashpath);
            }
        }
    ];

    $scope.viewOnly = false;
    $scope.showSelected = false;
    symptomsData.populateStaticList();
    if(symptomsData.uname === $scope.uname && symptomsData.symptomsList )
        $scope.symptomsList =  symptomsData.symptomsList;
    else
    {
        symptomsData.symptomsList = null;
        symptomsData.getSymptomsList().then(function (symptomsList) {
            $scope.symptomsList = symptomsList;
            symptomsData.symptomsList =  $scope.symptomsList;
            symptomsData.uname = $scope.uname;
        }, function (response) {
            console.log(response);
        });
    }

    $scope.dislimit=function(note)
    {
        var limitnote=note;
        if(note.length>20)
        {
            limitnote= note.substring(0,20) ;
        }
        return limitnote;
    }

    $scope.deleteItem = function (listIndex) {
        $ionicPopup.confirm({
            title: 'Delete condition?',
            content: 'Are you sure you want to delete?'
        }).then(function(res) {
                if(res) {
                    $scope.symptomsList =  symptomsData.symptomsList;
                    symptomsData.symptoms.delete({uname:$scope.uname,id: $scope.symptomsList[listIndex]._id}, function () {
                            $scope.symptomsList.splice(listIndex, 1);
                        },
                        function (response) {
                        });
                } else {
                }
            });
    };
}]);

evaidyaApp.controller('SymptomsDetailCtrl', ['$scope', '$location', '$stateParams','$filter', 'symptomsData', 'eVaidyaCache', function SymptomsDetailCtrl($scope, $location, $stateParams ,$filter, symptomsData, eVaidyaCache) {
    var isNew = false;
    $scope.symptomsStaticList = eVaidyaCache.symptomsStaticList();
    $scope.symptomsStaticAreaList = eVaidyaCache.symptomsStaticAreaList();
    $scope.symptomsList =  symptomsData.symptomsList;
    symptomsData.getSymptomsList().then(function (symptomsList) {
        $scope.symptomsList = symptomsList;
        symptomsData.symptomsList = symptomsList;
    if($stateParams.id >= 0)
    // shallow copy the object
        $scope.symptomsData = jQuery.extend({}, $scope.symptomsList[$stateParams.id]);
    else if($stateParams.id === "-1")
    {
        $scope.symptomsData = {measureDate:new Date()
            , symptomName:""
            , symptomDetails: ""
            , Note: ""
            , active: true
            ,patientId: $scope.getUserName()};
        isNew = true;
    }
    else // clone the first element
    {
        $scope.symptomsData = jQuery.extend({}, $scope.symptomsList[0]);
        isNew = true;
    }
        $scope.symptomsData.measureDate = $filter("date")($scope.symptomsData.measureDate, 'yyyy-MM-dd');
    });
    $scope.save  = function () {
        if(isNew)
        {
            symptomsData.symptoms.save({uname:$scope.uname},$scope.symptomsData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                    symptomsData.symptomsList.push(event);
                    // sort - very important
                    symptomsData.symptomsList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
        }
        else
            symptomsData.symptoms.update({uname:$scope.uname}, $scope.symptomsData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                           jQuery.each(symptomsData.symptomsList, function(j, el) {
                            if (event._id === el._id)
                            {
                                symptomsData.symptomsList[j] = event;
                                return false; // break the loop
                            }
                        });
                    // sort - very important
                    symptomsData.symptomsList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
    };

}]);
