'use strict';
evaidyaApp.controller('UrineTestListCtrl',['$scope','$ionicPopup', '$location',  'urineTestData', 'eVaidyaCache', function UrineTestListCtrl($scope,$ionicPopup, $location, urineTestData, eVaidyaCache) {
    $scope.itemButtons = [
        {
            text: 'Delete',
            type: 'button-assertive',
            onTap: function(item) {
                $scope.deleteItem(item);            }
        },
        {
            text: 'Edit',
            type: 'button-calm',
            onTap: function(item) {
                var hashpath = "/evaidya/urinetestdetail/"+ item;
                $location.path(hashpath);
            }
        }
    ];

    $scope.viewOnly = false;
    $scope.showSelected = false;
    if(urineTestData.uname === $scope.uname && urineTestData.urineTestList )
        $scope.urineTestList =  urineTestData.urineTestList;
    else
    {
        urineTestData.urineTestList = null;
        urineTestData.geturineTestList().then(function(urineTestList){
            $scope.urineTestList = urineTestList;
            urineTestData.urineTestList =  $scope.urineTestList;
            urineTestData.uname = $scope.uname;
        }, function(response){ console.log(response);});
    }

    $scope.deleteItem = function (listIndex) {
        $ionicPopup.confirm({
            title: 'Delete Urine Test?',
            content: 'Are you sure you want to delete?'
        }).then(function(res) {
                if(res) {
                    $scope.urineTestList = urineTestData.urineTestList;
                    urineTestData.urineTest.delete({uname: $scope.uname, id: $scope.urineTestList[listIndex]._id}, function () {
                            $scope.urineTestList.splice(listIndex, 1);
                        },
                        function (response) {
                        });
                } else {
                }
            });
    };
}]);

evaidyaApp.controller('UrineTestDetailCtrl',['$scope', '$location', '$stateParams','$filter','urineTestData', 'eVaidyaCache', function UrineTestDetailCtrl($scope, $location, $stateParams,$filter,urineTestData, eVaidyaCache) {
    var isNew = false;
    urineTestData.geturineTestList().then(function (urineTestList) {
        $scope.urineTestList = urineTestList;
        urineTestData.urineTestList =  $scope.urineTestList;
        $scope.colorValues = ["Clear", "Pale yellow", "Dark yellow", "Orange", "Pink", "Red"];
        if ($stateParams.id >= 0)
        // shallow copy the object
            $scope.urineTestData = jQuery.extend({}, $scope.urineTestList[$stateParams.id]);
        else if ($stateParams.id === "-1") {
            $scope.urineTestData = {measureDate: new Date(), uColor: "Clear", pH: 6.5, SpecGravity: 1, protein: 0, glucose: 0, Ketones: 30, Leukocytes: 0, WBCs: 0, RBCs: 0, casts: "", Bacteria: 0, patientId: $scope.getUserName()};
            isNew = true;
        }
        else // clone the first element
        {
            $scope.urineTestData = jQuery.extend({}, $scope.urineTestList[0]);
            isNew = true;
        }
        $scope.urineTestData.measureDate = $filter("date")($scope.urineTestData.measureDate, 'yyyy-MM-dd');
    });
    $scope.save  = function () {
        if(isNew)
        {
            urineTestData.urineTest.save({uname: $scope.uname},$scope.urineTestData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                    urineTestData.urineTestList.push(event);
                    // sort - very important
                    urineTestData.urineTestList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
        }
        else
            urineTestData.urineTest.update({uname: $scope.uname},$scope.urineTestData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                    jQuery.each(urineTestData.urineTestList, function (j, el) {
                        if (event._id === el._id) {
                            urineTestData.urineTestList[j] = event;
                            return false; // break the loop
                        }
                    });
                    // sort - very important
                    urineTestData.urineTestList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
    };

}]);


