'use strict';
evaidyaApp.controller('VitalsListCtrl', ['$scope','$rootScope', '$window', 'vitalsData','$ionicPopup', function VitalsListCtrl($scope,$rootScope, $window, vitalsData,$ionicPopup) {
    $scope.viewOnly = false;

    $scope.profileusername="Welcome <b>"+profileusername+"</b>";
    if(vitalsData.uname === $scope.uname && vitalsData.vitalsList )
    {

        $scope.vitalsList =  vitalsData.vitalsList;
        $scope.plotseries = vitalsData.plotseries;
    }
    else
    {
        $scope.plotseries = [
            {
                name: "DiastolicBP",
                data: []
            },
            {
                name: "SystolicBP",
                data: []
            },
            {
                name: "BMI",
                data: []
            }
        ];
        vitalsData.getVitalsList().then(function (vitalsList) {
            $scope.vitalsList = vitalsList;
            vitalsData.vitalsList = vitalsList;
            vitalsData.uname = $scope.uname;

            for (var i=0;i<$scope.vitalsList.length;i++)
            {
                $scope.plotseries[0].data.push($scope.vitalsList[i].diastolicBP);
                $scope.plotseries[1].data.push($scope.vitalsList[i].systolicBP);
                $scope.plotseries[2].data.push($scope.vitalsList[i].BMI);
            };
            vitalsData.plotseries = $scope.plotseries;
        }, function (response) {
            console.log(response);
        });
    }

        $scope.deleteItem = function (listIndex)
    {
            
            $ionicPopup.confirm({
                title: 'Delete Vitals?',
                content: 'Are you sure you want to delete?'
            }).then(function(res) 
        	{
                    if(res) {
                         $scope.vitalsList = vitalsData.vitalsList;
                    vitalsData.vitals.delete({uname: $scope.uname, id: $scope.vitalsList[listIndex]._id}, function () {
                            if ($scope.vitalsList)
                                $scope.vitalsList.splice(listIndex, 1);
                        },
                        function (response) {
                        });
                        } else {
                    }
                });
        
            /*if (result == true) {
                $scope.vitalsList = vitalsData.vitalsList;
                vitalsData.vitals.delete({uname: $scope.uname, id: $scope.vitalsList[listIndex]._id}, function () {
                        if ($scope.vitalsList)
                            $scope.vitalsList.splice(listIndex, 1);
                    },
                    function (response) {
                    });
            }
            else {
            }*/
        };
}]);

evaidyaApp.controller('VitalsDetailCtrl',['$scope', '$location', '$routeParams','vitalsData', function VitalsDetailCtrl($scope, $location, $routeParams,vitalsData) {
    var isNew = false;
    vitalsData.getVitalsList().then(function (vitalsList) {
        $scope.vitalsList = vitalsList;
        vitalsData.vitalsList = vitalsList;
        var routeid = Number($routeParams.id);
        if(routeid >= 0)
            // shallow copy the object
            $scope.vitalsData = jQuery.extend({}, vitalsData.vitalsList[routeid]);
        else if($routeParams.id === "-1")
        {
            $scope.vitalsData = {measureDate:new Date()
            , systolicBP:0
            , diastolicBP:0
            ,pulse:0
            ,respiratoryRate:0
            ,height:0
            ,heightUnits:"CM"
            ,weight:0
            ,weightUnits:"KG"
            ,BMI:0
            ,temperature:0
            ,tempUnits:"F"
            ,patientId: $scope.getUserName()};
            isNew = true;
        }
        else // clone the first element
        {
            $scope.vitalsData = jQuery.extend({}, $scope.vitalsList[0]);
            isNew = true;
        }
    });
        $scope.$watch('vitalsData.weight /((vitalsData.height/100)*(vitalsData.height/100))', function (value) {
            if(isNaN(value))
                value =0;
            else
            $scope.vitalsData.BMI = value.toFixed(2);
        });

        $scope.save  = function () {
            if(isNew)
            {
                vitalsData.vitals.save({uname:$scope.uname},$scope.vitalsData,function (event) {
                        vitalsData.vitalsList.push(event);
                        event.measureDate = new Date(event.measureDate);
                        // sort - very important
                        vitalsData.vitalsList.sort(function (el1, el2) {
                            return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                        });
                        $scope.$back();
                    },
                    function (response) {});
            }
            else
            vitalsData.vitals.update({uname:$scope.uname},$scope.vitalsData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                    jQuery.each(vitalsData.vitalsList, function(j, el) {
                        if (event._id === el._id)
                        {
                            vitalsData.vitalsList[j] = event;
                            return false; // break the loop
                        }
                    });
                    // sort - very important
                    vitalsData.vitalsList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});

        };

}]);