'use strict';
evaidyaApp.controller('bGlucoseListCtrl',['$scope', '$stateParams', '$location', 'bGlucoseData', '$ionicPopup', 'eVaidyaCache', function bGlucoseListCtrl($scope, $stateParams,$location, bGlucoseData, $ionicPopup, eVaidyaCache) {
    $scope.viewOnly = false;
    $scope.showSelected = false;
    $scope.itemButtons = [
        {
            text: 'Delete',
            type: 'button-assertive',
            onTap: function(item) {
                $scope.deleteItem(item);            }
        },
        {
            text: 'Edit',
            type: 'button-calm',
            onTap: function(item) {
                var hashpath = "/evaidya/bGlucosedetail/"+ item;
                $location.path(hashpath);
            }
        }
    ];

    if($stateParams.id == 0)
        $scope.istrend = true;
    $scope.dislimit=function(note)
    {
        var limitnote=note;
        if(note.length>20)
        {
            limitnote= note.substring(0,20) ;
        }
        return limitnote;
    }


    $scope.latestGlucoseVal =0;

    $scope.chartOptions = {
        scale: {
            startValue: 0,
            endValue: 200,
            majorTick: {
                length: 10,
                color: 'white',
                tickInterval: 10
            },
            minorTick: {
                length: 5,
                visible: true,
                color: 'black',
                tickInterval: 1
            }
        },
        value: $scope.latestGlucoseVal,
        valueIndicator: {
            type: 'rangeBar',
            color: 'darkcyan',
            /*            type: 'triangleNeedle',
             spindleGapSize: 5,
             width: 5,
             spindleSize: 25,
             color: 'black',
             */
            text: {
                indent: 2,
                format: 'decimal',
                font: {
                    color: 'darkcyan',
                    size: 18,
                    weight: 400
                }
            }
        },
        rangeContainer: {
            backgroundColor: 'black',
            width :15,
            ranges: [{
                startValue: 60,
                endValue: 105,
                color: 'green'
            }, {
                startValue: 106,
                endValue: 170,
                color: 'orange'
            },
                {
                    startValue: 170,
                    endValue: 200,
                    color: 'red'
                }
            ]
        },
        title: {
            text: 'Latest Glucose Reading',
            font: {
                size: 12,
                weight: 700
            },
            position: 'bottom-center'
        },
        label: {
            format: 'decimal',
            indent: 5,
            font: {
                size: 12,
                weight: 700
            }
        }
    };


    $scope.trendOptions = {
        dataSource: $scope.trendchartDataSource,
        commonSeriesSettings: {
            type: 'spline',
            argumentField: 'measureDate'
        },
        legend: {
            verticalAlignment: 'bottom',
            horizontalAlignment: 'center',
            itemTextPosition: 'right'
        },
        series: [
            { valueField: 'bloodGlucose', name: 'BloodGlucose' }
        ],
        margin: {
            left : 20,
            top: 20
        },
        valueAxis: {
            min: 0,
            max: 200,
            constantLines: [{
                label: {
                    text: ''
                },
                width: 2,
                value: 80,
                color: 'green',
                dashStyle: 'dash'
            }, {
                label: {
                    text: 'BorderLine'
                },
                width: 2,
                value: 105,
                color: '#ff4500',
                dashStyle: 'dash'
            }]
        },
        tooltip: { enabled: true }
    };

    if($scope.istrend)
    {
        $("#glucoseChart").dxCircularGauge($scope.chartOptions);
        $("#trendChart").dxChart($scope.trendOptions);
    }

    $scope.updateChartData = function(){
        if($scope.bGlucoseList.length > 0)
        {
            $scope.trendchartDataSource = [];
            for (var i=$scope.bGlucoseList.length -1 ;i>=0;i--)
            {
                if(i===0) // show the first item
                    $scope.latestGlucoseVal = $scope.bGlucoseList[i].bloodGlucose;
                $scope.trendchartDataSource.push({measureDate: $scope.bGlucoseList[i].measureDate.toLocaleDateString(), bloodGlucose: $scope.bGlucoseList[i].bloodGlucose});
            };

        }
    }

    if(bGlucoseData.uname === $scope.uname && bGlucoseData.bGlucoseList )
    {
        $scope.bGlucoseList =  bGlucoseData.bGlucoseList;
        if($scope.istrend)
        {
            $scope.updateChartData();
            $("#glucoseChart").dxCircularGauge('option','value',$scope.latestGlucoseVal);
            $("#trendChart").dxChart('option','dataSource',$scope.trendchartDataSource);
        }
    }
    else
    {
        bGlucoseData.bGlucoseList = null;
        bGlucoseData.getbGlucoseList().then(function(bGlucoseList){
            $scope.bGlucoseList = bGlucoseList;
            bGlucoseData.bGlucoseList =  $scope.bGlucoseList;
            bGlucoseData.uname = $scope.uname;
            if($scope.istrend)
            {
                $scope.updateChartData();
                $("#glucoseChart").dxCircularGauge('option','value',$scope.latestGlucoseVal);
                $("#trendChart").dxChart('option','dataSource',$scope.trendchartDataSource);
            }
//            $("#glucoseChart").dxCircularGauge('option','value',$scope.latestGlucoseVal);
        }, function(response){ console.log(response);});
    }



    $scope.deleteItem  = function (listIndex) {
        $ionicPopup.confirm({
            title: 'Delete Blood Glucose Record?',
            content: 'Are you sure you want to delete?'
        }).then(function(res) {
                if(res) {
                    //$scope.bGlucoseList[listIndex]
                    $scope.bGlucoseList = bGlucoseData.bGlucoseList;
                    bGlucoseData.bGlucose.delete({uname:$scope.uname,id:$scope.bGlucoseList[listIndex]._id},function () {
                            $scope.bGlucoseList.splice(listIndex, 1);
                        },
                        function (response) {
                        });
                } else {
                }
            });
    };
}]);

evaidyaApp.controller('bGlucoseDetailCtrl', ['$scope', '$location', '$stateParams', '$filter', 'bGlucoseData', 'eVaidyaCache', function bGlucoseDetailCtrl($scope, $location, $stateParams,$filter, bGlucoseData, eVaidyaCache) {
    $scope.bGlucoseList = bGlucoseData.bGlucoseList;
    $scope.typeValues =  ["Fasting","Random", "Post Prandial"];
    var isNew = false;
    bGlucoseData.getbGlucoseList().then(function(bGlucoseList){
        $scope.bGlucoseList = bGlucoseList;
        bGlucoseData.bGlucoseList =  $scope.bGlucoseList;
    if($stateParams.id >= 0)
    // shallow copy the object
        $scope.bGlucoseData = jQuery.extend({}, $scope.bGlucoseList[$stateParams.id]);
    else if($stateParams.id === "-1")
    {
        $scope.bGlucoseData = {measureDate:new Date()
            , bloodGlucose: ""
            , type: "Fasting"
            , Note: ""
            ,patientId: $scope.getUserName()};
        isNew = true;
    }
    else // clone the first element
    {
        $scope.bGlucoseData = jQuery.extend({}, $scope.bGlucoseList[0]);
        $scope.bGlucoseData.measureDate = new Date();
        isNew = true;
    }
        $scope.bGlucoseData.measureDate = $filter("date")($scope.bGlucoseData.measureDate, 'yyyy-MM-dd');
    });
    $scope.save  = function () {
        if(isNew)
        {
            bGlucoseData.bGlucose.save({uname: $scope.uname},$scope.bGlucoseData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                    bGlucoseData.bGlucoseList.push(event);
                    // sort - very important
                    bGlucoseData.bGlucoseList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
        }
        else
            bGlucoseData.bGlucose.update({uname: $scope.uname},$scope.bGlucoseData,function (event) {
                    event.measureDate = new Date(event.measureDate);
                    jQuery.each(bGlucoseData.bGlucoseList, function (j, el) {
                        if (event._id === el._id) {
                            bGlucoseData.bGlucoseList[j] = event;
                            return false; // break the loop
                        }
                    });
                    // sort - very important
                    bGlucoseData.bGlucoseList.sort(function (el1, el2) {
                        return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                    });
                    $scope.$back();
                },
                function (response) {});
    };

}]);
