/**
 * Created by venkat on 10/27/13.
 */

evaidyaApp.controller('FilesUploadCtrl',['$scope', '$routeParams', 'filesData', 'eVaidyaCache', function FilesUploadCtrl($scope, $routeParams, filesData, eVaidyaCache) {

    $scope.description = "";
    $scope.fileToken = new Date().getTime();
    $scope.getFileInfo = function(e) {
        return $.map(e.files, function(file) {
            var info = file.name;

            // File size is not available in all browsers
            if (file.size > 0) {
                info  += " (" + Math.ceil(file.size / 1024) + " KB)";
            }
            return info;
        }).join(", ");
    }



    var filename=[];
    $scope.onUpload = function(event) {
        //storing file name in cache for storing filename in consultation schema
        filename.push($scope.fileToken+event.files[0].name);

        eVaidyaCache.setFileName( filename);
        event.data = {username: $scope.uname, fileToken: $scope.fileToken, description: $scope.description,  kiosk: $scope.kioskName};
    }



    $scope.onRemove = function(event) {
        event.data = {username: $scope.uname, fileToken: $scope.fileToken, kiosk: $scope.kioskName};
    };

    $scope.onComplete = function(event) {
        filesData.filesList = null; // clear the cache in service
    };

    $scope.uploadOptions =   {
        async: {
            saveUrl: "/evaidya_api/upload",
            removeUrl: "/evaidya_api/deleteuploaded",
            autoUpload: true
        },
        remove: $scope.onRemove,
        upload: $scope.onUpload,
        complete: $scope.onComplete
    };
}]);

'use strict';
evaidyaApp.controller('FilesListCtrl', ['$scope', '$window', 'filesData', function FilesListCtrl($scope, $window, filesData) {


    $scope.dislimit=function(note)
    {
        var limitnote=note;
        if(note.length>20)
        {
            limitnote= note.substring(0,20) ;
        }
        return limitnote;
    }
    if(filesData.uname === $scope.uname && filesData.filesList )
        $scope.filesList =  filesData.filesList ;
    else
    {
        filesData.getFilesList().then(function (filesList) {
            $.each(filesList, function (j, el) {
                el.created = new Date(el.created);
            });
            // sort - very important
            filesList.sort(function (el1, el2) {
                return (el2.created > el1.created) ? 1 : ( (el1.created > el2.created) ? -1 : 0 );
            });
            $scope.filesList = filesList;
            filesData.filesList = filesList;
            filesData.uname = $scope.uname;
        }, function (response) {
            //console.log(response);
        });
    }

    $scope.deleteItem = function (listIndex) {
        var result = window.confirm("Are you sure want to delete this item?");
            if(result==true)
            {
        //$scope.vitalsList[listIndex]
        $scope.filesList = filesData.filesList;
        filesData.files.delete({username:$scope.uname,fileNames: $scope.filesList[listIndex].filename}, function () {
                if($scope.filesList)
                    $scope.filesList.splice(listIndex, 1);
            },
            function (response) {
            });
        }
        else
        {

        }
    };
}]);
