'use strict';
evaidyaApp.controller('PhotoCaptureCtrl',
    ['$scope','$rootScope', 'userData', 'eVaidyaCache', function UserListCtrl($scope,$rootScope, userData, eVaidyaCache) {
var _video = null,
    _stream = null,
    patData = null;

$scope.patOpts = {x: 0, y: 0, w: 25, h: 25};

$scope.webcamError = false;
$scope.onError = function (err) {
    $scope.$apply(
        function() {
            $scope.webcamError = err;
        }
    );
};

$scope.onSuccess = function (videoElem) {
    // The video element contains the captured camera data
    _video = videoElem;
    $scope.$apply(function() {
        $scope.patOpts.w = _video.width;
        $scope.patOpts.h = _video.height;

    });
};

$scope.onStream = function (stream, videoElem) {
    _stream = stream;
    // You could do something manually with the stream.
};

/**
 * Make a snapshot of the camera data and show it in another canvas.
 */
$scope.makeSnapshot = function makeSnapshot() {
    if (_video) {
        var patCanvas = document.querySelector('#snapshot');
        if (!patCanvas) return;

        patCanvas.width = _video.width;
        patCanvas.height = _video.height;
        var ctxPat = patCanvas.getContext('2d');

        var idata = getVideoData($scope.patOpts.x, $scope.patOpts.y, $scope.patOpts.w, $scope.patOpts.h);
        ctxPat.putImageData(idata, 0, 0);

        patData = idata;
    }
};

$scope.save = function(){
    //save it in the service
    userData.currentImageData = {};
    userData.currentImageData.data = patData;
    userData.currentImageData.width = _video.width;
    userData.currentImageData.height = _video.height;
    if(_stream)
        _stream.stop();
    $scope.$back();
};

$scope.cancel = function(){
    if(_stream)
        _stream.stop();
    $scope.$back();
};


var getVideoData = function getVideoData(x, y, w, h) {
    var hiddenCanvas = document.createElement('canvas');
    hiddenCanvas.width = _video.width;
    hiddenCanvas.height = _video.height;
    var ctx = hiddenCanvas.getContext('2d');
    ctx.drawImage(_video, 0, 0, _video.width, _video.height);
    return ctx.getImageData(x, y, w, h);
};

}]);