'use strict';

angular.module('ionicApp')
    .factory('Auth',['$http', '$rootScope', '$cookieStore', '$location', function($http, $rootScope, $cookieStore, $location){

        var accessLevels = routingConfig.accessLevels
            , userRoles = routingConfig.userRoles
            , currentUser = $cookieStore.get('user') || { username: '', role: userRoles.public };

        function changeUser(user) {
            //set the cookie as well?
            jQuery.cookie('user', JSON.stringify({
                'username': user.username,
                'role': user.role
            }), { path: '/' })
            jQuery.extend(currentUser, user);
        };

        function clearCurrentUser(user) {
            jQuery.removeCookie('user', { path: '/' });
            currentUser.username = '';
            currentUser.role = userRoles.public;
        };

        function isLoggedIn(user) {
            if(user === undefined)
                user = currentUser;
/*            if(jQuery.cookie('connect.sid')=== undefined)
            {
                if(jQuery.cookie('user') !== undefined)
                {
                    bootbox.alert("You are logged out becuase of inactivity, please login again.");
                    clearCurrentUser();
                    $location.path('/login');
                }
            }
            */
            $http.get(APIUrl + '/evaidya_api/users/'+currentUser.username).success(function (data) {
                if(!data.phone)
                	$rootScope.UpdateMobileNo=true;
                else
                	$rootScope.UpdateMobileNo=false;
                
                
            }). error(function(error){
                    console.log(error);
                });
            return user.role.title == userRoles.user.title || user.role.title == userRoles.admin.title || user.role.title == userRoles.doctor.title;
        };


        return {
            authorize: function(accessLevel, role) {
                if(role === undefined)
                    role = currentUser.role;
                if(accessLevel === undefined)
                    return false;
                return accessLevel.bitMask & role.bitMask;
            },
               
           authRedirectLoggedIn: function() {
                if(isLoggedIn())
                {
                   //alert(JSON.stringify(currentUser.username));
                    $rootScope.userloggedIn = true;
                    $rootScope.uname = currentUser.username;
                    $rootScope.role = currentUser.role;
                    //alert($rootScope.role.bitMask);
                    //$rootScope.isDoctor = ($rootScope.role.bitMask = 4) ? true : false;
        			//$rootScope.isPatient = ($rootScope.role.bitMask = 2) ? true : false;
                    var redirUrl;
                    redirUrl = '/evaidya/home';
/*                    if($rootScope.onlineApp)
                    {
                        if(currentUser.role.title === userRoles.doctor.title)
                            redirUrl = '/session/doctor' + '/docname/' + currentUser.username + '/uname/'+  currentUser.username;
                        else if(currentUser.role.title === userRoles.admin.title)
                            redirUrl = '/session/admin' + '/adminname/' + currentUser.username + '/uname/'+  currentUser.username;
                        else
                            redirUrl = '/session/user' + '/uname/' + currentUser.username + '/uname/' + currentUser.username;

                    }
                    else
                    {
                            if(currentUser.role.title === userRoles.doctor.title)
                                redirUrl = '/session/doctor' + '/docname/' + currentUser.username + '/uname/default';
                            else
                                redirUrl = '/session/kiosk' + '/kname/' + currentUser.username + '/uname/default';
                    }
*/
                    $location.path( redirUrl );
                }
           },
            register: function (user, success, err) {
                $http.post(APIUrl + '/evaidya_api/register', user).success(function (user) {
                    changeUser(user);
                    success(user);
                }).error(function (error) {
                        err(error);
                    });
            },
            login: function(user, success, err) {
                var loginURL = APIUrl + "/evaidya_api/login";
                $http.post(loginURL, user).success(function(user){
                    changeUser(user);
                    success(user);
                }).error(function(error){
                  err(error);
                });
            },
            logout: function(success, error) {
                $http.post(APIUrl + '/evaidya_api/logout').success(function(){
                    clearCurrentUser({
                        username: '',
                        role: userRoles.public
                    });
                    success();
                }).error(error);
            },
            accessLevels: accessLevels,
            userRoles: userRoles,
            isLoggedIn:isLoggedIn,
            changeUser: changeUser,
            user: currentUser
            
        };
    }]);

angular.module('ionicApp')
    .factory('Users',['$http', function($http) {
        return {
            getAll: function(success, error) {
                $http.get(APIUrl + '/evaidya_api/users').success(success).error(error);
            }
        };
    }]);
