
evaidyaApp.factory('eVaidyaCache',['$angularCacheFactory', '$rootScope', function($angularCacheFactory, $rootScope) {
    var evCache = $angularCacheFactory('eVaidyaCache', {
        capacity: 1000,
//        maxAge: 300000, // Items added to this cache expire after 5 minutes
//        deleteOnExpire: 'aggressive', // Items will be actively deleted when they expire
//        cacheFlushInterval: 300000, // This cache will clear itself every 5 mins
        storageMode: 'localStorage'
    });

    // save state for new consultation
    var consultationCurrentSheet = 0;
    var consultationsData = undefined;
    var docCurrentConsultationData = undefined;
    var selectedDoc = undefined;

    return {
        evCache: evCache,
        consultationCurrentSheet:consultationCurrentSheet,
        docCurrentConsultationData:docCurrentConsultationData,
        consultationsData:consultationsData,
        selectedDoc: function(){
//            return evCache.get('selectedDoc');
            return selectedDoc;
        },
        setSelectedDoc: function(doc){
            selectedDoc = doc;
            //   evCache.put('selectedDoc', doc);
        },
        setConsultReason:function(reason,summary)
        {
            evCache.put('setConsultReason', reason);
            evCache.put('setConsultSummary', summary);
        },
        selectedConsultReason:function()
        {
            return evCache.get('setConsultReason');


        },
        selectedConsultSummary:function()
        {

            return evCache.get('setConsultSummary');

        },
        setFileName: function(filename){


            evCache.put('fileName',filename);

            //   evCache.put('selectedDoc', doc);
        },
        selectFileName:function()
        {
            return evCache.get('fileName');
        },
        /*        vitalsList: function() {
         return evCache.get('vitalsList');
         },

         allergiesList: function() {
         return evCache.get('allergiesList');
         },*/
        allergiesStaticList: function() {
            return evCache.get('allergiesStaticList');
        },
        immunizationsStaticList: function() {
            return evCache.get('immunizationsStaticList');
        },
        /*        symptomsList: function() {
         return evCache.get('symptomsList');
         },*/
        symptomsStaticList: function() {
            return evCache.get('symptomsStaticList');
        },
        symptomsStaticAreaList: function() {
            return evCache.get('symptomsStaticAreaList');
        },
        userEmail:function()
        {
            return evCache.get('userEmail');
        },
        /*        medicationsList: function() {
         return evCache.get('medicationsList');
         },
         consultationsList: function() {
         return evCache.get('consultationsList');
         },
         doc_consultationsList: function() {
         return evCache.get('doc_consultationsList');
         },*/
        medicationsStaticList: function() {
            return evCache.get('medicationsStaticList');
        },
        docList: function() {
            return evCache.get('docList');
        },
        findDoc: function(userName) {
            var found;
            var docList = evCache.get('docList');
            if(docList)
            {
                jQuery.each(docList, function(j, el) {
                    if (userName === el.username)
                    {
                        found = el;
                        return false; // break the loop
                    }
                });
            }
            return found;
        }
    };
}]);

//Doctors data using $resource
evaidyaApp.factory('doctorData',['$resource','$http','$q', 'eVaidyaCache', function ($resource, $http,$q, eVaidyaCache) {
    $http.defaults.useXDomain = true;
    var doctors = $resource(APIUrl+'/evaidya_api/doctors/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    var Doc = $resource(APIUrl+'/evaidya_api/doctors/:userId', {userId:'@id'});

    return {
        getDoctorList: function () {
            var deferred = $q.defer();
            Doc.query(function (event) {
                    jQuery.each(event, function (i, el) {
                        if(el.image ==="")
                            el.image = "images/eharticle.jpg"
                        // fix the URL issue
                        el.image = HOMEUrl+'/'+el.image;
                        //console.log(el.image);
                    });
                    eVaidyaCache.evCache.put('docList', event);
                    deferred.resolve(event);},
                function (response) {deferred.reject(response);
                });
            return deferred.promise;
        },
        getDoctor: function(uid){
            var deferred = $q.defer();
            Doc.get({userId:uid},
                function(event) {
                    if(event.image ==="")
                        event.image = "images/eharticle.jpg"
                    event.image = HOMEUrl+'/'+event.image;
                    deferred.resolve(event);},
                function (response){deferred.reject(response);
                });
            return deferred.promise;
        } ,
        updateDoctorProfile:function(doctor){
            var deferred = $q.defer();
            $http.put(APIUrl+'/evaidya_api/doctors/'+doctor._id,doctor).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        } ,
        getAllDoctors:function(doctor){
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/doctorlist',{params:{name:doctor}}).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        DisableDoctor:function(doctor)
        {

            var deferred = $q.defer();

            $http.put(APIUrl+'/evaidya_api/doctorlist/'+doctor._id+'/false').success(function(data)
            {
                deferred.resolve(data);
            }).error(function(error)
                {
                    deferred.reject(error);
                })
            return deferred.promise;
        },

        EnableDoctor:function(doctor)
        {

            var deferred = $q.defer();

            $http.put(APIUrl+'/evaidya_api/doctorlist/'+doctor._id+'/true').success(function(data)
            {
                deferred.resolve(data);
            }).error(function(error)
                {
                    deferred.reject(error);
                })
            return deferred.promise;
        }


    };
}]);

//Vitals data using $resource
evaidyaApp.factory('vitalsData',['$resource','$http','$q','$rootScope', 'eVaidyaCache', function ($resource, $http, $q,$rootScope, eVaidyaCache) {
    var vitals = $resource(APIUrl+'/evaidya_api/vitals/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});

    return {
        getVitalsList: function () {
            var deferred = $q.defer();
            if(!this.vitalsList)
            {
                vitals.query({uname:$rootScope.uname}, function (event) {
                        $.each(event, function (j, el) {
                            el.measureDate = new Date(el.measureDate);
                        });
                        // sort - very important
                        event.sort(function (el1, el2) {
                            return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                        });
                        this.vitalsList = event;
                        deferred.resolve(event);},
                    function (response) {deferred.reject(response);
                    });
            }
            else
                deferred.resolve(this.vitalsList);
            return deferred.promise;
        },
        getLatestVitals: function (uname) {
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/vitals-latest/' + uname).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        vitals: vitals
    };

}]);

//BP data using $resource
evaidyaApp.factory('BPData',['$resource','$http','$q','$rootScope', 'eVaidyaCache', function ($resource, $http, $q,$rootScope, eVaidyaCache) {
    var bp = $resource(APIUrl+'/evaidya_api/bp/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});

    return {
        getBPList: function () {
            var deferred = $q.defer();
            if(!this.bpList)
            {
                bp.query({uname:$rootScope.uname}, function (event) {
                        $.each(event, function (j, el) {
                            el.measureDate = new Date(el.measureDate);
                        });
                        // sort - very important
                        event.sort(function (el1, el2) {
                            return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                        });
                        this.bpList = event;
                        deferred.resolve(event);},
                    function (response) {deferred.reject(response);
                    });
            }
            else
                deferred.resolve(this.bpList);
            return deferred.promise;
        },
        getLatestBP: function (uname) {
            var deferred = $q.defer();
            $http.get(APIUrl + '/evaidya_api/bp-latest/' + uname).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        bp: bp
    };

}]);


//filesData  using $resource
evaidyaApp.factory('filesData', ['$resource','$q','$rootScope', function ($resource, $q,$rootScope) {
    var files = $resource(APIUrl+'/evaidya_api/files/:username/:fileNames', {username:'@username', fileNames:'@fileNames'});
    return {
        getFilesList: function () {
            var deferred = $q.defer();
            files.query({username:$rootScope.uname}, function (event) {
                    deferred.resolve(event);},
                function (response) {deferred.reject(response);
                });
            return deferred.promise;
        },
        files: files
    };

}]);


//stethData  using $resource
evaidyaApp.factory('stethData', ['$resource','$q','$rootScope',function ($resource, $q,$rootScope) {
    var stethfiles = $resource(APIUrl+'/evaidya_api/stethfiles/:username/:filename', {username:'@username', filename:'@filename'});
    return {
        getFilesList: function () {
            var deferred = $q.defer();
            stethfiles.query({username:$rootScope.uname}, function (event) {
                    deferred.resolve(event);},
                function (response) {deferred.reject(response);
                });
            return deferred.promise;
        },
        stethfiles: stethfiles
    };

}]);


//Symptoms Data
evaidyaApp.factory('symptomsData',['$resource','$q','$rootScope', 'eVaidyaCache', function ($resource, $q,$rootScope, eVaidyaCache) {
    var symptoms = $resource(APIUrl+'/evaidya_api/symptoms/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    var symptomsStatics = $resource(APIUrl+'/evaidya_api/symptomslist', {});

    return {
        populateStaticList: function() {
            var deferred = $q.defer();
            var symptomsStaticList = eVaidyaCache.evCache.get('symptomsStaticList');
            var symptomsStaticAreaList = eVaidyaCache.evCache.get('symptomsStaticAreaList');
            if (!symptomsStaticList) {
                symptomsStatics.query(function (event) {
                    var areaDupes = {};
                    var staticListTmp = [];
                    var staticAreaTmp = [];
                    $.each(event, function (i, el) {
                        staticListTmp.push(el.symptomName);
                        if (el.symptomDetails !== '' && !areaDupes[el.symptomDetails]) {
                            areaDupes[el.symptomDetails] = true;
                            staticAreaTmp.push(el.symptomDetails);
                        }
                    });
                    eVaidyaCache.evCache.put('symptomsStaticList', staticListTmp);
                    eVaidyaCache.evCache.put('symptomsStaticAreaList', staticAreaTmp);
                }, function (response) {
                    deferred.reject(response);
                });
            }
            else
                deferred.resolve(symptomsStaticList);
            return deferred.promise;
        },
        getSymptomsList: function () {
            var deferred = $q.defer();
            if(!this.symptomsList)
            {
                symptoms.query({uname:$rootScope.uname}, function (event) {
                        $.each(event, function (j, el) {
                            el.measureDate = new Date(el.measureDate);
                        });
                        // sort - very important
                        event.sort(function (el1, el2) {
                            return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                        });
                        this.symptomsList = event;
                        deferred.resolve(this.symptomsList);},
                    function (response) {deferred.reject(response);
                    });
            }
            else
                deferred.resolve(this.symptomsList);
            return deferred.promise;
        },
        symptoms: symptoms
    };

}]);

//Medications Data
evaidyaApp.factory('medicationsData',['$resource','$q','$rootScope', 'eVaidyaCache', function ($resource, $q,$rootScope, eVaidyaCache) {
    var medications = $resource(APIUrl+'/evaidya_api/medications/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    var medicationsStatics = $resource(APIUrl+'/evaidya_api/medicinelist', {});

    return {
        populateStaticList: function() {
            var deferred = $q.defer();
            var medicationsStaticList = eVaidyaCache.evCache.get('medicationsStaticList');
            if (!medicationsStaticList) {
                medicationsStatics.query(function (event) {
                    var staticListTmp = [];
                    $.each(event, function(i, el) {
                        staticListTmp.push(el.medicineName);
                       
                    });
                    eVaidyaCache.evCache.put('medicationsStaticList', staticListTmp);
                }, function (response) {
                    deferred.reject(response);
                });
            }
            else
                deferred.resolve(medicationsStaticList);
            return deferred.promise;
        },
        getMedicationsList: function () {
            var deferred = $q.defer();
            if(!this.medicationsList)
            {
                medications.query({uname:$rootScope.uname},function (event) {
                        $.each(event, function(j, el) {
                            el.startDate = new Date(el.startDate);
                            el.stopDate = new Date(el.stopDate);
                            // selected field only used as required
                            el.selected = false;
                        });
                        // sort - very important
                        event.sort( function(el1, el2) {
                            return (el2.startDate > el1.startDate) ? 1 : ( (el1.startDate > el2.startDate) ? -1 : 0 );
                        });
                        this.medicationsList = event;
                        deferred.resolve(this.medicationsList);},
                    function (response) {deferred.reject(response);
                    });
            }
            else
                deferred.resolve(this.medicationsList);
            return deferred.promise;
        },
        medications: medications
    };

}]);

//Consultations Data
evaidyaApp.factory('consultationsData',['$resource','$q','$http','$rootScope', 'eVaidyaCache', function ($resource, $q,$http,$rootScope, eVaidyaCache) {
    var consultations = $resource(APIUrl+'/evaidya_api/consultations/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    var kioskconsults = $resource(APIUrl+'/evaidya_api/kioskconsults/:kname', {kname:'@kname'}, {
        update: {method:'PUT'}});
    var docconsults = $resource(APIUrl+'/evaidya_api/doc_consultations/:docname', {docname:'@docname'}, {
        update: {method:'PUT'}});
    var adminconsults = $resource(APIUrl+'/evaidya_api/adminconsults');

    return {
        getConsultationsList: function (consultReason,itemsPerPage,PageNumber) {
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/consultations/'+$rootScope.uname,{params:{reason:consultReason,resultsPerPage:itemsPerPage,pageNumber:PageNumber}}).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });

            return deferred.promise;
        },

        getAdminConsultsList: function (patientName,consultReason,status,itemsPerPage,PageNumber) {
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/adminconsults',{params:{patient:patientName,reason:consultReason,status:status,resultsPerPage:itemsPerPage,pageNumber:PageNumber}}).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });

            return deferred.promise;
        },
        getKioskConsultsList: function (patientName,consultReason,itemsPerPage,PageNumber) {
            var deferred = $q.defer();
            if($rootScope.kioskName === undefined)
            {
                $rootScope.kioskName = eVaidyaCache.evCache.get("kioskName");

            }

            $http.get(APIUrl+'/evaidya_api/kioskconsults/'+$rootScope.kioskName,{params:{patient:patientName,reason:consultReason,resultsPerPage:itemsPerPage,pageNumber:PageNumber}}).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        getDocConsultsList: function (patientName,consultReason,itemsPerPage,PageNumber) {
            var deferred = $q.defer();
            if($rootScope.doctorName === undefined)
            {
                $rootScope.doctorName = eVaidyaCache.evCache.get("doctorName");

            }
            
            $http.get(APIUrl+'/evaidya_api/doc_consultations/'+$rootScope.uname,{params:{patient:patientName,reason:consultReason,resultsPerPage:itemsPerPage,pageNumber:PageNumber}}).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        consultations: consultations,
        kioskconsults:kioskconsults,
        docconsults:docconsults

    };
}]);

//Doc Consultations Data
evaidyaApp.factory('docConsultationsData',['$resource','$q','$rootScope', 'eVaidyaCache', function ($resource, $q,$rootScope, eVaidyaCache) {
    var doc_consultations = $resource(APIUrl+'/evaidya_api/doc_consultations/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    return {
        getDocConsultationsList: function () {
            var deferred = $q.defer();
            var consultationsList = eVaidyaCache.evCache.get('doc_consultationsList');
            if(!consultationsList)
            {
                doc_consultations.query(function (event) {
                        eVaidyaCache.evCache.put('doc_consultationsList', event);
                        deferred.resolve(event);},
                    function (response) {deferred.reject(response);
                    });
            }
            else
                deferred.resolve(consultationsList);
            return deferred.promise;
        },
        doc_consultations: doc_consultations
    };

}]);

//Allergies Data
evaidyaApp.factory('allergiesData',['$resource','$q','$rootScope', 'eVaidyaCache', function ($resource, $q,$rootScope, eVaidyaCache) {
    var allergies = $resource(APIUrl+'/evaidya_api/allergies/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    var allergiesStatics = $resource(APIUrl+'/evaidya_api/allergieslist', {});

    return {
        populateStaticList: function() {
            var deferred = $q.defer();
            var allergiesStaticList = eVaidyaCache.evCache.get('allergiesStaticList');
            if (!allergiesStaticList) {
                allergiesStatics.query(function (event) {
                    eVaidyaCache.evCache.put('allergiesStaticList', event[0].Allergies);
                }, function (response) {
                    deferred.reject(response);
                });
            }
            else
                deferred.resolve(allergiesStaticList);
            return deferred.promise;
        },
        getAllergiesList: function () {
            var deferred = $q.defer();
            if(!this.allergiesList)
                allergies.query({uname:$rootScope.uname},function (event) {
                        $.each(event, function(j, el) {
                            el.measureDate = new Date(el.measureDate);
                        });
                        // sort - very important
                        event.sort( function(el1, el2) {
                            return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                        });
                        this.allergiesList = event;
                        deferred.resolve(event);},
                    function (response) {deferred.reject(response);
                    });
            else
                deferred.resolve(this.allergiesList);
            return deferred.promise;
        },
        allergies: allergies
    };

}]);

//Users data using $resource
evaidyaApp.factory('userData',['$resource','$http', '$q','$rootScope', 'eVaidyaCache',  function ($resource, $http,$q, $rootScope, eVaidyaCache) {
    $http.defaults.useXDomain = true;
    var user = $resource(APIUrl+'/evaidya_api/users/:username', { username:'@username'},{
        update: {method:'PUT'}});
    return {
        getUserInfo: function(uid){
            if(!uid)
            	uid = $rootScope.uname;
            
            var deferred = $q.defer();
            user.get({username:uid},function(event) {
                    if(event.image ==="")
                        event.image = '/img/newuser.png'
                    deferred.resolve(event);},
                function (response){deferred.reject(response);
                });
           
            return deferred.promise;
        },
        getUserList: function (uname, uaddress, uphone, ucity,itemsPerPage,PageNumber) {
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/userlist', {params: {name: uname, address: uaddress, phone: uphone, city: ucity,resultsPerPage:itemsPerPage,pageNumber:PageNumber}}).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        getnewUserList: function (word,perpage,curpage) {
            var deferred = $q.defer();

            $http.get(APIUrl + '/evaidya_api/newusers',{params:{word:word,resultsPerPage:perpage,pageNumber:curpage}}).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },

        checkUsername: function (uname) {
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/checkUsername', {params: {name: uname}}).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        checkUserEmail: function (email) {
            var deferred = $q.defer();

            $http.get(APIUrl+'/evaidya_api/checkUseremail',{params:{email:email}}).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){

                    deferred.reject(error);
                });
            return deferred.promise;
        },
        changePwdEmail:function(email)
        {

            var deferred = $q.defer();

            $http.put(APIUrl+'/evaidya_api/sendpwdemail/'+email ).success(function(data)
            {
                deferred.resolve(data);
            }).error(function(error)
                {
                    deferred.reject(error);
                })
            return deferred.promise;
        },
        user : user
    };
}]);

//Blood Glucose Data
evaidyaApp.factory('bGlucoseData',['$resource','$q','$rootScope', 'eVaidyaCache',  function ($resource, $q,$rootScope, eVaidyaCache) {
    var bGlucose = $resource(APIUrl+'/evaidya_api/bGlucose/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});

    return {
        getbGlucoseList: function () {
            var deferred = $q.defer();
            if(!this.bGlucoseList)
                bGlucose.query({uname:$rootScope.uname},function (event) {
                        $.each(event, function(j, el) {
                            el.measureDate = new Date(el.measureDate);
                        });
                        // sort - very important
                        event.sort( function(el1, el2) {
                            return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                        });
                        this.bGlucoseList = event;
                        deferred.resolve(event);},
                    function (response) {deferred.reject(response);
                    });
            else
                deferred.resolve(this.bGlucoseList);
            return deferred.promise;
        },
        bGlucose: bGlucose
    };

}]);

//lipid Profile Data
evaidyaApp.factory('lipidProfileData', ['$resource','$q','$rootScope', 'eVaidyaCache', function ($resource, $q,$rootScope, eVaidyaCache) {
    var lipidProfile = $resource(APIUrl+'/evaidya_api/lipidProfile/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});

    return {
        getlipidProfileList: function () {
            var deferred = $q.defer();
            if(!this.lipidProfileList)
            {
                lipidProfile.query({uname:$rootScope.uname},function (event) {
                        $.each(event, function(j, el) {
                            el.measureDate = new Date(el.measureDate);
                        });
                        // sort - very important
                        event.sort( function(el1, el2) {
                            return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                        });
                        this.lipidProfileList = event;
                        deferred.resolve(this.lipidProfileList);},
                    function (response) {deferred.reject(response);
                    });
            }
            else
                deferred.resolve(this.lipidProfileList);
            return deferred.promise;
        },
        lipidProfile: lipidProfile
    };
}]);

//lipid Profile Data
evaidyaApp.factory('urineTestData',['$resource','$q','$rootScope', 'eVaidyaCache', function ($resource, $q,$rootScope, eVaidyaCache) {
    var urineTest = $resource(APIUrl+'/evaidya_api/urineTest/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});

    return {
        geturineTestList: function () {
            var deferred = $q.defer();
            if(!this.urineTestList)
            {
                urineTest.query({uname:$rootScope.uname},function (event) {
                        $.each(event, function(j, el) {
                            el.measureDate = new Date(el.measureDate);
                        });
                        // sort - very important
                        event.sort( function(el1, el2) {
                            return (el2.measureDate > el1.measureDate) ? 1 : ( (el1.measureDate > el2.measureDate) ? -1 : 0 );
                        });
                        this.urineTestList = event;
                        deferred.resolve(this.urineTestList);},
                    function (response) {deferred.reject(response);
                    });
            }
            else
                deferred.resolve(this.urineTestList);
            return deferred.promise;
        },
        urineTest: urineTest
    };

}]);

//Immunizations Data
evaidyaApp.factory('immunizationsData',['$resource','$q','$rootScope', 'eVaidyaCache',  function ($resource, $q,$rootScope, eVaidyaCache) {
    var immunizations = $resource(APIUrl+'/evaidya_api/immunizations/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    var immunizationsStatics = $resource(APIUrl+'/evaidya_api/immunizationlist', {});

    return {
        populateStaticList: function() {
            var deferred = $q.defer();
            var immunizationsStaticList = eVaidyaCache.evCache.get('immunizationsStaticList');
            if (!immunizationsStaticList) {
                immunizationsStatics.query(function (event) {
                    eVaidyaCache.evCache.put('immunizationsStaticList', event[0].Immunizations);
                }, function (response) {
                    deferred.reject(response);
                });
            }
            else
                deferred.resolve(immunizationsStaticList);
            return deferred.promise;
        },
        getImmunizationsList: function () {
            var deferred = $q.defer();
            if(!this.immunizationsList)
                immunizations.query({uname:$rootScope.uname},function (event) {
                        $.each(event, function(j, el) {
                            el.OccurDate = new Date(el.OccurDate);
                        });
                        // sort - very important
                        event.sort( function(el1, el2) {
                            return (el2.OccurDate > el1.OccurDate) ? 1 : ( (el1.OccurDate > el2.OccurDate) ? -1 : 0 );
                        });
                        this.immunizationsList = event;
                        deferred.resolve(this.immunizationsList);},
                    function (response) {deferred.reject(response);
                    });
            else
                deferred.resolve(this.immunizationsList);
            return deferred.promise;
        },
        immunizations: immunizations
    };

}]);


//Discussions Data
evaidyaApp.factory('discussionsData',['$resource','$http', '$q','$rootScope', 'eVaidyaCache',  function ($resource,$http, $q,$rootScope, eVaidyaCache) {
    var discussions = $resource(APIUrl+'/evaidya_api/discussions/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    var usrrole="";
    if($rootScope.doctorMenu)
    {
        usrrole="doctor";
    }
    else
    {
        usrrole="user";
    }




    return {
        getDiscussionsList: function (DiscussionTitle,resultsPerPage,pageNumber ) {
            DiscussionTitle = DiscussionTitle || "";
            resultsPerPage = resultsPerPage || 10;
            pageNumber = pageNumber || 1;
            var deferred = $q.defer();
            if(!this.discussionList)
                $http.get(APIUrl+'/evaidya_api/discussions',{params: {usrtype:usrrole,title: DiscussionTitle,resultsPerPage: resultsPerPage, pageNumber: pageNumber}}).success(function (data) {
                    var discussionList = data.items;
                    $.each(discussionList, function (j, el) {
                        el.replied = new Date(el.replied);
                        el.modified = new Date(el.modified);
                        el.created = new Date(el.created);
                        // selected field only used as required
                        //            el.selected = false;
                    });
                    // sort - very important
                    discussionList.sort(function (el1, el2) {
                        return (el2.replied > el1.replied) ? 1 : ( (el1.replied > el2.replied) ? -1 : 0 );
                    });
                    this.discussionList = data;
                    deferred.resolve(this.discussionList );
                }). error(function(error){
                        deferred.reject(error);
                    });
            else
                deferred.resolve(this.discussionList );
            return deferred.promise;
        },
        getRepliesList: function (id) {
            var userType = 'not_registered';
            if ($rootScope.userMenu) {
                userType='user';
             }
             if ($rootScope.doctorMenu) {
                userType='doctor';
             }
             if ($rootScope.adminMenu) {
                userType='admin';
             }
             var loggedUserName = $rootScope.uname;

             console.log('Will call discussionReplies for userType: ' + userType);
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/discussionReplies/'+ id + '/' + userType + '/' + loggedUserName).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        hits: function (count,discussionID) {
            var deferred = $q.defer();
            $http.put(APIUrl+'/evaidya_api/discussions/hits/'+discussionID+'/'+count).success(function(data)
            {
                deferred.resolve(data);
            }).error(function(err)
                {
                    deferred.reject(err);
                })

            return deferred.promise;
        },

        discussions: discussions
    };
}]);


//Articles Data
evaidyaApp.factory('articlesData', ['$resource','$http', '$q','$rootScope', 'eVaidyaCache', function ($resource,$http, $q,$rootScope, eVaidyaCache) {
    var articles = $resource(APIUrl+'/evaidya_api/articles/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    return {
        getArticlesList: function (title, resultsPerPage,pageNumber ) {
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/articles',{params: {title:title,  resultsPerPage: resultsPerPage, pageNumber: pageNumber}}).success(function (data) {

                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        getAdminArticlesList: function (title, resultsPerPage,pageNumber ) {
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/adminArticles',{params: {title:title,  resultsPerPage: resultsPerPage, pageNumber: pageNumber}}).success(function (data) {

                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        getArticle: function (id ) {
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/articles/'+id).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        addArticle: function (article) {
            var deferred = $q.defer();
            $http.post('/evaidya_api/addarticles/',article).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        changeStatus: function (id,status) {
            var deferred = $q.defer();
            $http.put(APIUrl+'/evaidya_api/articles/updatestatus/'+id+'/'+status).success(function (data) {
                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        articles: articles
    };
}]);


//Plans Data

evaidyaApp.factory('plansData',['$resource', '$http','$q','$rootScope', 'eVaidyaCache',  function ($resource,$http, $q,$rootScope, eVaidyaCache) {

    var plans = $resource(APIUrl+'/evaidya_api/plans/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    var plansList;
    return {
        getplansList: function () {
            var deferred = $q.defer();
            if(!plansList)
            {
                plans.query(function (event) {
                        plansList = event;
                        deferred.resolve(event);},
                    function (response) {deferred.reject(response);
                    });
            }
            else
                deferred.resolve(plansList);
            return deferred.promise;
        },
        //getting user balance when upgrading his plan
        getAmount: function () {
            var deferred = $q.defer();
            $http.get(APIUrl+'/evaidya_api/users/balance/'+ $rootScope.uname).success(function (data) {

                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        plans: plans
    };
}]);


//Plans Data
evaidyaApp.factory('membershipsData',['$resource', '$http', '$q','$rootScope', function ($resource, $http, $q,$rootScope) {
    var memberships = $resource(APIUrl+'/evaidya_api/memberships/:uname/:id', {uname:'@uname', id:'@id'}, {
        update: {method:'PUT'}});
    return {
        getUserMemberships: function () {
            var deferred = $q.defer();

            $http.get(APIUrl+'/evaidya_api/memberships/patient/'+ $rootScope.uname).success(function (data) {

                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        checkAccess: function (type, amount) {
           

            var deferred = $q.defer();
            if($rootScope.isKiosk)
                deferred.resolve("Approved");
            else
            {
            $http.get(APIUrl+'/evaidya_api/checkAccess/'+$rootScope.uname +"/" + type +"/" + amount).success(function (data) {

                deferred.resolve(data);
                console.log(data)
            }). error(function(error){
                console.log(error)
                    deferred.reject(error);
                });
            }
            return deferred.promise;
        },
        checkAccessDoctor: function (docName) {
            var deferred = $q.defer();
            if($rootScope.isKiosk)
                deferred.resolve("Approved");
            else
            {
            $http.get(APIUrl+'/evaidya_api/checkAccessDoctor/'+ $rootScope.uname +"/" + docName).success(function (data) {

                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            }
            return deferred.promise;
        },
        deductAmount: function ( amount) {
            var deferred = $q.defer();
            $http.put(APIUrl+'/evaidya_api/plans/'+ $rootScope.uname +"/" + amount  ).success(function (data) {


                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },
        updateUserStatus: function (membershipId ) {
            var deferred = $q.defer();
            $http.put(APIUrl+'/evaidya_api/memberships/user/'+ $rootScope.uname +'/'+membershipId+'/Expired').success(function (data) {


                deferred.resolve(data);
            }). error(function(error){
                    deferred.reject(error);
                });
            return deferred.promise;
        },

        memberships: memberships
    };
}]);

//Kiosks User Data
evaidyaApp.factory('kiosksData',['$resource','$q','$rootScope', 'eVaidyaCache', function ($resource, $q,$rootScope, eVaidyaCache) {
    var kiosks = $resource(APIUrl+'/evaidya_api/kiosks/:id', {id:'@id'}, {
        update: {method:'PUT'}});

    return {
        getkiosksList: function () {
            var deferred = $q.defer();
            if(!this.kiosksList)
            {
                kiosks.query({uname:$rootScope.uname},function (event) {
                        this.kiosksList = event;
                        deferred.resolve(this.kiosksList);},
                    function (response) {deferred.reject(response);
                    });
            }
            else
                deferred.resolve(this.kiosksList);
            return deferred.promise;
        },
        kiosks: kiosks
    };
}]);

//filesuploadData  using $resource
evaidyaApp.factory('filesuploadData', ['$resource','$q','$rootScope', function ($resource, $q,$rootScope) {
   
       var Files = $resource(APIUrl+'/evaidya_api/files/:username/:fileNames', {username:'@username', fileNames:'@fileNames'});

            angular.extend($scope, {

                model: { file: null },

                upload: function(model) {
                    Files.prototype.$save.call(model.file, function(self, headers) {
                        // Handle server response
                    });
                }
            });

}]);
