evaidyaApp.factory('messageService',['$resource', '$rootScope', '$location', function ($resource, $rootScope, $location) {
    // Initialize the socket, set up event handler, and connect
    var socket = io.connect(APIUrl);
  

    function sendUserMessage(msg,  patId, docId, cnsltId)
    {
            socket.emit(msg, {user: $rootScope.uname, patientId: patId, doctorId: docId,consultationId:cnsltId});
    }
    function sendDoctorMessage(msg, body)
    {
        socket.emit(msg, {doctor: $rootScope.doctorName, body: body });
    }
    function sendLikesAndRatingMessage(msg,  patId, docId, disId)
    {
            socket.emit(msg, {user: $rootScope.uname, patientId: patId, doctorId: docId,discussionId:disId});
    }
    

    socket.on("new_consultation", function messageHandler(message) {
        
        if($rootScope.userloggedIn && $rootScope.role.bitMask == 4 && message.doctorId === $rootScope.uname){
            
             document.addEventListener('deviceready', function () {
                 
                 window.plugin.notification.local.add({
                        id:         '1',  // A unique id of the notifiction
                        date:       new Date(),    // This expects a date object
                        message:    "New Consulation Request from - " + message.patientId + "- Do you want to see the request?",  // The message that is displayed
                        title:      "New Consultation",  // The title of the message
                        //repeat:     String,  // Either 'secondly', 'minutely', 'hourly', 'daily', 'weekly', 'monthly' or 'yearly'
                        //badge:      Number,  // Displays number badge to notification
                        //sound:      String,  // A sound to be played
                        json:       JSON.stringify(message),  // Data to be passed through the notification
                        autoCancel: true, // Setting this flag and the notification is automatically canceled when the user clicks it
                        //ongoing:    Boolean, // Prevent clearing of notification (Android only)
                    });
                 
                 window.plugin.notification.local.onclick = function(id, state, json){ 
                     //console.log(json);
                     //console.log(JSON.parse(json).consultationId);
                     //console.log($location.path())
                     $location.path("/evaidya/docconsultations/"+JSON.parse(json).consultationId).replace();
                     $rootScope.$apply();                     
                 };
                 
            }, false);
            
            
             //$scope.$apply();  
            
        }         
    });

    socket.on("prescription", function messageHandler(message) {
        
        if($rootScope.userloggedIn && $rootScope.role.bitMask == 2 &&  message.patientId === $rootScope.uname){
            
            document.addEventListener('deviceready', function () {
                
                 window.plugin.notification.local.add({
                        id:         '2',  // A unique id of the notifiction
                        //date:       Date,    // This expects a date object
                        message:    "Prescription Complete from - " +  message.doctorId + " for -" + message.patientId + "- Do you want to see the consultation?",  // The message that is displayed
                        title:      "Prescription",  // The title of the message
                        //repeat:     String,  // Either 'secondly', 'minutely', 'hourly', 'daily', 'weekly', 'monthly' or 'yearly'
                        //badge:      Number,  // Displays number badge to notification
                        //sound:      String,  // A sound to be played
                        json:       JSON.stringify(message),  // Data to be passed through the notification
                        autoCancel: true, // Setting this flag and the notification is automatically canceled when the user clicks it
                        //ongoing:    Boolean, // Prevent clearing of notification (Android only)
                    });
                
                window.plugin.notification.local.onclick = function(id, state, json){ 
                     //console.log(json);
                     //console.log(JSON.parse(json).consultationId);
                     //console.log($location.path())
                     $location.path("/evaidya/docconsultations/"+JSON.parse(json).consultationId).replace();
                     $rootScope.$apply();                     
                 };
                
            }, false);
            
        }
    });
    socket.on("likes", function messageHandler(message) {
        
               
        if($rootScope.userloggedIn && $rootScope.role.bitMask == 4 && message.doctorId === $rootScope.uname){
            
             document.addEventListener('deviceready', function () {
                 window.plugin.notification.local.add({
                        id:         '3',  // A unique id of the notifiction                       
                        message:    "Likes From - " + message.patientId + "- Do you want to see the Likes?",  // The message that is displayed
                        title:      "Likes",  // The title of the message                     
                        json:       JSON.stringify(message),  // Data to be passed through the notification
                        autoCancel: true, // Setting this flag and the notification is automatically canceled when the user clicks it                      
                        state : "foreground",
                        
                    });     
             window.plugin.notification.local.onclick = function(id, state, json){
                    //console.log(json);
                     //console.log(JSON.parse(json).consultationId);
                     //console.log($location.path())
                     $location.path("evaidya/discussiondetail/"+JSON.parse(json).discussionId+"/").replace();
                     $rootScope.$apply();
                 };    
                 
            }, false);            
                    
        }         
        
    });
    socket.on("discussion_rating", function messageHandler(message) {
        
               
        if($rootScope.userloggedIn && $rootScope.role.bitMask == 4 && message.doctorId === $rootScope.uname){
            
             document.addEventListener('deviceready', function () {
                 window.plugin.notification.local.add({
                        id:         '4',  // A unique id of the notifiction                       
                        message:    "Discussion Rating From - " + message.patientId + "- Do you want to see the Rating?",  // The message that is displayed
                        title:      "Discussion Rating",  // The title of the message                     
                        json:       JSON.stringify(message),  // Data to be passed through the notification
                        autoCancel: true, // Setting this flag and the notification is automatically canceled when the user clicks it                      
                    }); 
                    window.plugin.notification.local.ontrigger = function (id, state, json) {
                        
                        //console.log(json);
                     //console.log(JSON.parse(json).consultationId);
                     //console.log($location.path())
                     $location.path("evaidya/discussiondetail/"+JSON.parse(json).discussionId+"/").replace();
                     $rootScope.$apply();
                    };
                 
            }, false);            
                    
        }         
        
    });

    return {
        sendNewConsultationMessage : function(patientId, docId,  consultId){            
 
            sendUserMessage("new_consultation",  patientId, docId,  consultId );
        },
        sendPrescriptionMessage : function(patientId, docId,  consultId){
            
            sendUserMessage("prescription",  patientId, docId,consultId );
        },
         sendDiscussionLikes: function(patientId,docId,disId){
             //console.log("Iam from Discussion Likes Patient Id="+patientId+"Doctor Id="+docId+"Discussions Id:"+disId);
             sendLikesAndRatingMessage("likes",  patientId, docId, disId);
        },
        sendDiscussionRating : function(patientId,docId,disId)
        {
            sendLikesAndRatingMessage("discussion_rating",  patientId, docId,  disId);
            //console.log("Iam from Discussion Rating Patient Id="+patientId+"Doctor Id="+docId+"Discussions Id:"+disId);
        },
        init: function()
        {

        }
    };
}]);
